/**
 * FatMaika - Version 1.13
 * Copyright 2017, RoninWP
 * http://roninwp.com
 */
var fat_maika_process = 0;
    "use strict";
    (function ($) {
    var FatMaika = new function () {
        this.init = function () {
            FatMaika.initPopupGallery();
            FatMaika.initIsotope();
            FatMaika.initFilter();
            FatMaika.initLoadMore();
            FatMaika.initJustified();
            FatMaika.initCarousel();
            setTimeout(function () {
                FatMaika.initHorizontalSlide();
            }, 100);
            setTimeout(function () {
                FatMaika.initAlbumPreview();
            }, 500);
            FatMaika.removeAutotop();
            FatMaika.initAnimation();
        };

        this.removeAutotop = function () {
            $('section.cd-container > p', '.fat-maika-container.timeline').remove();
        };

        this.initFilter = function () {
            $('.fat-maika-category-filter .fat-maika-category a').off('click').on('click', function (event) {
                if (fat_maika_process == 1) {
                    return;
                }
                var self = $(this),
                    container = self.closest('.fat-maika-container'),
                    cat_container = self.closest('.fat-maika-category-filter'),
                    category = self.attr('data-category'),
                    cat_filter = '',
                    item_per_page = container.attr('data-item-per-page');

                item_per_page = typeof item_per_page!='undefined' && item_per_page!='' ? item_per_page : 1000;

                event.preventDefault();

                if (container.hasClass('carousel')) {
                    $('.fat-maika-category a.active', container).removeClass('active');
                    self.addClass('active');
                    if (category == 'j1_1') {
                        $('.fat-gallery-item', container).each(function () {
                            if ($(this).hasClass('filter-hidden')) {
                                $(this).removeClass('filter-hidden');
                                $(this).closest('.owl-item').fadeIn();
                            }
                        });
                    } else {
                        $('.fat-gallery-item', container).each(function () {
                            if ($(this).hasClass(category)) {
                                if ($(this).hasClass('filter-hidden')) {
                                    $(this).removeClass('filter-hidden');
                                    $(this).closest('.owl-item').fadeIn();
                                }
                            } else {
                                $(this).closest('.owl-item').fadeOut();
                                $(this).addClass('filter-hidden');
                            }
                        });
                    }

                    // $('.fat-maika-listing.owl-carousel',container).data('owlCarousel').trigger('refresh.owl.carousel');
                    fat_maika_process = 0;
                    return;
                }

                if ($.isFunction($.fn.isotope)) {
                    fat_maika_process = 1;

                    $('.fat-maika-category a.active', container).removeClass('active');
                    self.addClass('active');
                    if (category == 'j1_1') {
                        cat_filter = '*';
                        container.addClass('root-filter');
                    } else {
                        container.removeClass('root-filter');
                        var cat = category.split(',');
                        cat_filter = '';
                        for (var $i = 0; $i < cat.length; $i++) {
                            if ($i == 0) {
                                cat_filter += '.' + cat[$i];
                            } else {
                                cat_filter += ', .' + cat[$i];
                            }
                        }
                    }

                    if (cat_container.hasClass('cat-skin-04')) {
                        var cat_root = self.attr('data-root'),
                            is_sub_cat = self.closest('.sub-cat-wrap');

                        cat_container.removeClass('has-sub');
                        if (typeof is_sub_cat == 'undefined' || is_sub_cat.length == 0) {
                            $('.fat-maika-category-filter .sub-cat-wrap', container).hide();
                            $('.fat-maika-category-filter .sub-cat-wrap.' + cat_root, container).show();
                            if ($('.fat-maika-category-filter .sub-cat-wrap.' + cat_root, container).length > 0) {
                                cat_container.addClass('has-sub');
                            }
                        }
                    }

                    var $cat_arr = category.split(','),
                        item_cat_class = '',
                        item_hidden_cat_class = '';
                    for (var $cat_index = 0; $cat_index < $cat_arr.length; $cat_index++) {
                        item_cat_class += '.fat-gallery-item.' + $cat_arr[$cat_index] + ':not(.maika-lazy-load),';
                        item_hidden_cat_class += '.fat-gallery-item.maika-lazy-load.' + $cat_arr[$cat_index] + ',';
                    }
                    item_cat_class = item_cat_class.slice(0, item_cat_class.lastIndexOf(","));
                    item_hidden_cat_class = item_hidden_cat_class.slice(0, item_hidden_cat_class.lastIndexOf(","));

                    var total_item = $(item_cat_class, container).length,//$('.fat-gallery-item.' + category+':not(.maika-lazy-load)', container).length,
                        total_item_hidden = $(item_hidden_cat_class, container).length, //$('.fat-gallery-item.maika-lazy-load.' + category, container).length,
                        index = 0,
                        img_src = '';

                    if (total_item < item_per_page && total_item_hidden > 0) {
                        $(item_hidden_cat_class, container).each(function () {
                            if (index < (item_per_page - total_item)) {
                                $(this).addClass('waiting-init');
                                img_src = $('.fat-maika-item-inner', this).attr('data-thumb');
                                $('.fat-maika-item-inner img', this).remove();
                                if($(this).hasClass('item-skin-08')){
                                    $('.fat-maika-item-inner a.view-gallery', this).prepend('<img src="' + img_src + '">');
                                }else{
                                    $('.fat-maika-item-inner', this).prepend('<img src="' + img_src + '">');
                                }
                            }
                            index++;
                        });

                        container.imagesLoaded(function () {
                            var items = $('.fat-gallery-item.waiting-init', container);
                            items.removeClass('maika-lazy-load');
                            $('.fat-maika-listing', container).isotope('insert', items);
                            if (container.hasClass('has-animation')) {
                                FatMaika.initAppearScroll(container);
                            } else {
                                $('.fat-gallery-item.waiting-init', container).removeClass('waiting-init');
                            }

                            $('.fat-maika-listing', container).isotope({
                                filter: cat_filter
                            });
                        });
                    } else {
                        //cat_filter
                        var load_more = $('.fat-maika-paging-container.load-more', container);
                        if (category == 'j1_1') {
                            cat_filter = '*';
                            container.addClass('root-filter');
                        }
                        if(load_more.length > 0 && load_more.is(':visible')){
                            var $idx_item = 0;
                            var cf = cat_filter.replace('.','');
                            console.log('cf:' + cf);
                            $('.fat-maika-listing', container).isotope({
                                filter: function(){
                                    $idx_item += (cf=='*' || $(this).hasClass(cf)) ? 1 : 0;
                                    return ($idx_item <= item_per_page) && (cf=='*' || $(this).hasClass(cf));
                                }
                            });
                        }else{
                            $('.fat-maika-listing', container).isotope({
                                filter: cat_filter
                            });
                        }

                        setTimeout(function () {
                            FatMaika.initAnimation();
                        }, 1000);
                    }
                    FatMaika.updatePagingStatus(container, cat_filter);
                    setTimeout(function () {
                        fat_maika_process = 0;
                    }, 500);
                }

            });

            $('select.fat-maika-category-mobile').on('change',function(){
                var category = $(this).val(),
                    container = $(this).closest('.fat-maika-container');

                $('.fat-maika-category a[data-category="' + category +'"]', container).trigger('click');

            });
        };

        this.initLoadMore = function () {
            $('.fat-maika-paging-container.load-more a,.fat-maika-paging-container a.infinite-scroll').off('click').on('click', function () {
                var self = $(this),
                    total = parseInt(self.attr('data-total')),
                    item_per_page = parseInt(self.attr('data-item-per-page')),
                    total_display = $('.fat-gallery-item:not(.maika-lazy-load)', container).length,
                    container = self.closest('.fat-maika-container'),
                    index = 0,
                    img_src = '',
                    category_active = $('.fat-maika-category-filter .fat-maika-category a.active', container).attr('data-category');

                if (typeof (category_active) === 'undefined' || category_active == 'j1_1') {
                    $('.fat-gallery-item.maika-lazy-load:not(.waiting-init)', container).each(function () {
                        if (index < item_per_page) {
                            $(this).addClass('waiting-init');
                            img_src = $('.fat-maika-item-inner', this).attr('data-thumb');
                            $('.fat-maika-item-inner img', this).remove();
                            if($(this).hasClass('item-skin-08')){
                                $('.fat-maika-item-inner a.view-gallery', this).prepend('<img src="' + img_src + '">');
                            }else{
                                $('.fat-maika-item-inner', this).prepend('<img src="' + img_src + '">');
                            }
                        }
                        index++;
                    });
                } else {
                    var $arr_cat_active = category_active.split(',');
                    for (var $i = 0; $i < $arr_cat_active.length; $i++) {
                        $('.fat-gallery-item.maika-lazy-load.' + $arr_cat_active[$i], container).each(function () {
                            if (index < item_per_page) {
                                $(this).addClass('waiting-init');
                                img_src = $('.fat-maika-item-inner', this).attr('data-thumb');
                                $('.fat-maika-item-inner img', this).remove();
                                if($(this).hasClass('item-skin-08')){
                                    $('.fat-maika-item-inner a.view-gallery', this).prepend('<img src="' + img_src + '">');
                                }else{
                                    $('.fat-maika-item-inner', this).prepend('<img src="' + img_src + '">');
                                }
                            }
                            index++;
                        });
                    }
                }
                container.imagesLoaded(function () {
                    var items = $('.fat-gallery-item.waiting-init', container);
                    items.removeClass('maika-lazy-load');
                    $('.fat-maika-listing', container).isotope('insert', items);
                    $('.fat-maika-listing', container).isotope('layout');
                    if (container.hasClass('has-animation')) {
                        FatMaika.initAppearScroll(container);
                    } else {
                        $('.fat-gallery-item.waiting-init', container).removeClass('waiting-init');
                    }
                });
                if (category_active == 'j1_1' || typeof (category_active) === 'undefined') {
                    if ($('.fat-gallery-item.maika-lazy-load:not(.waiting-init)', container).length == 0) {
                        $(self).closest('.fat-maika-paging-container.load-more').fadeOut()
                    } else {
                        $(self).closest('.fat-maika-paging-container.load-more').fadeIn();
                    }
                } else {
                    if ($('.fat-gallery-item.maika-lazy-load.' + category_active + ':not(.waiting-init)', container).length == 0) {
                        $(self).closest('.fat-maika-paging-container.load-more').fadeOut()
                    } else {
                        $(self).closest('.fat-maika-paging-container.load-more').fadeIn();
                    }
                }
                setTimeout(function () {
                    if (self.hasClass('infinited')) {
                        self.removeClass('infinited');
                    }
                    FatMaika.initPopupGallery();
                }, 500);
                FatMaika.initLoadMore();
            });
        };

        this.initInfiniteScroll = function () {
            var windowTop = $(window).scrollTop(),
                windowBottom = windowTop + $(window).height(),
                elemTop, elemBottom;
            $('.fat-maika-paging-container.infinite a.infinite-scroll:not(.infinited)').each(function () {
                elemTop = $(this).offset().top;
                elemBottom = elemTop + $(this).height();
                if ((elemBottom <= windowBottom) && (elemTop >= windowTop)) {
                    $(this).addClass('infinited');
                    $(this).trigger('click');
                }
            });
        };

        this.initJustifiedInfinite = function () {
            $('.fat-maika-listing.justified.has-infinite').each(function () {
                var self = $(this),
                    container = self.closest('.fat-maika-container'),
                    justified_infinite = $('.justified-infinite', container),
                    item_per_page = $(justified_infinite).attr('data-item-per-page'),
                    url_img = '';
                if (FatMaika.isAppear(justified_infinite)) {
                    item_per_page = parseInt(item_per_page);
                    $('.justified-lazy-load > div', container).each(function (index, item) {
                        if (index <= item_per_page) {
                            url_img = $(item).attr('data-thumb');
                            $(item).prepend('<img src="' + url_img + '" />');
                            $(self).append($(item).clone(true));
                            $(self).justifiedGallery('norewind');
                            FatMaika.initPopupGallery();
                            $(item).remove();
                        }
                    })
                }
            })
        };

        this.updatePagingStatus = function (container, category) {
            var load_more = $('.fat-maika-paging-container.load-more', container);
            category = category == '*' ? '' : category;
            var cat = category.split(','),
                show = false;
            for (var $i = 0; $i < cat.length; $i++) {
                if ($('.fat-gallery-item.maika-lazy-load' + cat[$i] + ':not(.waiting-init)', container).length > 0) {
                    show = true;
                }
            }
            if (show) {
                load_more.show();
            } else {
                load_more.hide();
            }
        };

        this.initIsotope = function () {
            if ($.isFunction($.fn.isotope)) {
                $('.fat-maika-container.isotope').each(function () {
                    var container = $(this),
                        col_width = '.fat-col-md-' + container.attr('data-maika-col');

                    if ($('.fat-maika-listing', container).data('isotope')) {
                        $('.fat-maika-listing', container).isotope('destroy');
                    }
                    try {
                        if ($('.fat-maika-listing', container).data('isotope')) {
                            $('.fat-maika-listing', container).isotope('layout');
                        }
                    } catch (ex) {
                    }
                    if ($(container).hasClass('has-animation')) {
                        FatMaika.initAppearScroll($(container));
                    }
                    var $iso = $('.fat-maika-listing', container).isotope({
                        itemSelector: '.fat-gallery-item:not(.maika-lazy-load)',
                        masonry: {
                            columnWidth: col_width
                        },
                        percentPosition: true,
                        hiddenStyle: {
                            opacity: 0,
                            transform: 'translate3d(0, 100px, 0)'
                        },
                        visibleStyle: {
                            opacity: 1,
                            transform: 'translate3d(0, 0, 0)'
                        },
                        transitionDuration: '0.6s'
                    });

                    $iso.imagesLoaded(function () {
                        try {
                            setTimeout(function(){
                                $iso.isotope('layout');
                            },1000)
                        } catch (ex) {
                        }
                        if ($(container).hasClass('has-animation')) {
                            FatMaika.initAppearScroll($(container));
                        }
                    });

                    setTimeout(function () {
                        var $cat_active = $('.fat-maika-category-filter a.active');
                        if (typeof $cat_active != 'undefined' && $cat_active.length > 0 && $cat_active.attr('data-category') != 'j1_1') {
                            $cat_active.trigger('click');
                            container.removeClass('has-category-default');
                        } else {
                            container.removeClass('has-category-default');
                        }
                    }, 500)
                })
            }
        };

        this.initPopupGallery = function () {
            $('.fat-maika-container .fat-gallery-item a.view-gallery').off('click').on('click', function () {
                var self = $(this),
                    container = self.closest('.fat-maika-container'),
                    data = FatMaika.getGalleryImage(self);
                FatMaika.showPopupGallery(self, container, data.galleries, data.index);
            });

            $('.fat-maika-container .fat-gallery-item .fat-albums-tab-container img').off('click').on('click', function () {
                var self = $(this),
                    thumb_container = self.closest('.fat-albums-tab-container'),
                    container = self.closest('.fat-maika-container'),
                    galleries = [],
                    index = 0,
                    img = '';
                $('img, span.fat-album-hd-item', thumb_container).each(function () {
                    if (typeof ($(this).attr('data-video')) != 'undefined' && $(this).attr('data-video') != '') {
                        img = $(this).attr('data-video');
                    } else {
                        img = $(this).attr('data-img');
                    }
                    galleries.push({
                        'src': img,
                        'thumb': $(this).attr('data-thumb'),
                        'subHtml': '<h4>' + $(this).attr('data-title') + '</h4>' + $(this).attr('data-desc'),
                        'w': $(this).attr('data-width'),
                        'h': $(this).attr('data-height')
                    });
                });
             /*   if (!thumb_container.hasClass('hover-no-animation')) {
                    index = galleries.length - 1;
                }*/
                FatMaika.showPopupGallery(self, container, galleries, index);
            });

            $('.fat-maika-container.horizontal-slide .fat-item-thumb-wrap, .fat-maika-container.timeline .cd-timeline-img').off('click').on('click', function () {
                var self = $(this),
                    gallery = self.attr('data-gallery'),
                    galleries = [],
                    index = 0,
                    img = '',
                    container = self.closest('.fat-maika-container');

                gallery = $.parseJSON(gallery);
                for (var $i = 0; $i < gallery.length; $i++) {
                    if (typeof gallery[$i].video_embed != 'undefined' && gallery[$i].video_embed != '') {
                        img = gallery[$i].video_embed;
                    } else {
                        img = gallery[$i].url;
                    }
                    galleries.push({
                        'src': img,
                        'thumb': gallery[$i].thumb,
                        'subHtml': '<h4>' + gallery[$i].title + '</h4>' + gallery[$i].description,
                        'w': 900,
                        'h': 600
                    })
                }
                FatMaika.showPopupGallery(self, container, galleries, index);
            });

            $('.fat-maika-listing.justified .fat-album-view-gallery-icon').off('click').on('click', function () {
                var self = $(this),
                    galleries = [],
                    index = 0,
                    start_index = 0,
                    img = '',
                    view_icon = '',
                    current_img = self.attr('data-img'),
                    container = self.closest('.fat-maika-listing.justified');
                $('.fat-album-view-gallery-icon', container).each(function () {
                    view_icon = $(this);
                    if (typeof view_icon.attr('data-video') != 'undefined' && view_icon.attr('data-video') != '') {
                        img = view_icon.attr('data-video');
                    } else {
                        img = view_icon.attr('data-img');
                    }
                    if (img == current_img) {
                        start_index = index;
                    }
                    galleries.push({
                        'src': img,
                        'thumb': view_icon.attr('data-thumb'),
                        'subHtml': '<h4>' + view_icon.attr('data-title') + '</h4>' + view_icon.attr('data-desc'),
                        'w': 900,
                        'h': 600
                    });
                    index++;
                });
                FatMaika.showPopupGallery(self, container, galleries, start_index);
            });
        };

        this.showPopupGallery = function (elm, container, galleries, start_index) {
            if ((container.hasClass('fat-lightbox-gallery') || container.hasClass('lightbox-gallery')) && $.isFunction($.fn.lightGallery)) {
                elm.lightGallery({
                    downloadUrl: false,
                    download: $(container).hasClass('disable-download') ? false : true,
                    share: $(container).hasClass('disable-share') ? false : true,
                    dynamic: true,
                    dynamicEl: galleries,
                    hash: false,
                    index: start_index
                }).on('onAfterOpen.lg', function (event, index) {
                    if (!$(container).hasClass('show-thumbnail')) {
                        $('.lg-thumb-outer').css('opacity', '0');
                        setTimeout(function () {
                            $('.lg-has-thumb').removeClass('lg-thumb-open');
                            $('.lg-thumb-outer').css('opacity', '1');
                        }, 700);
                    }
                });
            }

            if (container.hasClass('fat-magnific-gallery') && $.isFunction($.fn.magnificPopup)) {
                $.magnificPopup.open({
                    gallery: {
                        enabled: true
                    },
                    items: galleries,
                    type: 'image',
                    mainClass: 'mfp-zoom-in',
                    removalDelay: 500, //delay removal by X to allow out-animation
                    callbacks: {
                        open: function () {
                            //overwrite default prev + next function. Add timeout for css3 crossfade animation
                            $.magnificPopup.instance.next = function () {
                                var self = this;
                                self.wrap.removeClass('mfp-image-loaded');
                                setTimeout(function () {
                                    $.magnificPopup.proto.next.call(self);
                                }, 120);
                            };
                            $.magnificPopup.instance.prev = function () {
                                var self = this;
                                self.wrap.removeClass('mfp-image-loaded');
                                setTimeout(function () {
                                    $.magnificPopup.proto.prev.call(self);
                                }, 120);
                            };
                            if (start_index > 0) {
                                $.magnificPopup.instance.goTo(start_index);
                            }
                        },
                        imageLoadComplete: function () {
                            var self = this;
                            setTimeout(function () {
                                self.wrap.addClass('mfp-image-loaded');
                            }, 16);
                        }
                    },
                    closeOnContentClick: true,
                    midClick: true
                });
            }
        },

        this.getGalleryImage = function (self) {
                var container = $(self).closest('.fat-maika-container'),
                    url = $(self).attr('data-img'),
                    start_index = 0,
                    index = 0,
                    galleries = [],
                    gallery_item = '';
                $('a.view-gallery', container).each(function () {
                    gallery_item = $(this).closest('.fat-gallery-item');
                    if (gallery_item.css('display') == 'block') {
                        if ($(this).attr('data-img') == url) {
                            start_index = index;
                        }
                        galleries.push({
                            'src': $(this).attr('data-img'),
                            'thumb': $(this).attr('data-thumb'),
                            'subHtml': '<h4>' + $(this).attr('data-title') + '</h4>' + $(this).attr('data-desc'),
                            'w': $(this).attr('data-width'),
                            'h': $(this).attr('data-height')
                        });
                        index++;
                    }
                });
                return {'galleries': galleries, 'index': start_index}
            };

        this.initAppearScroll = function ($container) {
            var windowTop = $(window).scrollTop(),
                windowBottom = windowTop + $(window).height(),
                $animation_duration = 100,
                elemTop, elemBottom, $items, $animation = 'fadeInUp';
            $items = [];
            $('.fat-gallery-item.has-infinite:not(.infinited):not(.maika-lazy-load)', $container).each(function () {
                if (FatMaika.isAppear(this)) {
                    $items.push($(this));
                }
            });

            for (var $i = 0; $i < $items.length; $i++) {
                (function ($index) {
                    $animation_duration = $($items[$index]).closest('.fat-maika-container').attr('data-animation-duration');
                    $animation_duration = typeof $animation_duration != 'undefined' ? parseInt($animation_duration) : 200;
                    var $delay = $animation_duration * $i;
                    setTimeout(function () {
                        $animation = $($items[$index]).closest('.fat-maika-container').attr('data-animation');
                        $($items[$index]).addClass('animated ' + $animation);
                        $($items[$index]).removeClass('has-infinite').removeClass('waiting-init');
                        $($items[$index]).addClass('infinited');
                        setTimeout(function () {
                            $($items[$index]).removeClass($animation);
                        }, 1500);
                    }, $delay);
                })($i);
            }
        };

        this.isAppear = function (elm, percent_height) {
            var windowTop = $(window).scrollTop(),
                windowBottom = windowTop + $(window).height(),
                $height = $(elm).height(),
                elemTop = $(elm).offset().top,
                elemBottom = elemTop + $height,
                $height_appear = elemBottom - windowBottom;
            if (typeof percent_height == 'undefined' || isNaN(percent_height)) {
                percent_height = 0.9;
            }
            if (($height_appear <= 0 || $height_appear <= ($height * percent_height)) && (elemTop >= windowTop || windowBottom > elemBottom)) {
                return true;
            }
            return false;
        };

        this.initAnimation = function () {
            $('.fat-gallery-item', '.fat-maika-container.has-animation').addClass('has-infinite');
            $('.fat-maika-container.has-animation').each(function () {
                FatMaika.initAppearScroll($(this));
            })
        };

        this.initAlbumPreview = function () {
            $('.fat-maika-container .album-preview').each(function () {
                var container = $(this);
                container.imagesLoaded(function () {
                    $('.fat-albums-tab-thumb', container).each(function () {
                        var imgHeight = $('img:first-child', this).outerHeight(),
                            fat_albums_tab_container = $(this).closest('.fat-albums-tab-container');
                        if (typeof imgHeight != 'undefined') {
                            $(this).css('height', imgHeight + 'px');
                            $(fat_albums_tab_container).css('height', imgHeight + 'px');
                        }
                    });
                });
            });
        };

        this.initHorizontalSlide = function () {
            $('.fat-maika-container.horizontal-slide .fat-maika-slide-items').each(function () {
                var container = $(this);
                $('.fat-gallery-item', container).each(function () {
                    var li = $(this),
                        fat_item_thumb = $('.fat-item-thumb', li),
                        imgHeight = $('img', fat_item_thumb).height();
                    if (typeof imgHeight != 'undefined') {
                        $(fat_item_thumb).css('height', imgHeight + 'px');
                    }
                });
                var itemHeight = $('li:first-child', container).outerHeight(true);
                if (typeof itemHeight != 'undefined') {
                    container.css('height', (itemHeight + 50) + 'px');
                }
                if ($.isFunction($.fn.perfectScrollbar)) {
                    container.perfectScrollbar({
                        wheelSpeed: 0.5
                    });
                }
            });
        };

        this.initJustified = function () {
            if ($.isFunction($.fn.justifiedGallery)) {
                $('.fat-maika-container .justified').each(function () {
                    var self = $(this),
                        rowHeight = self.attr('data-row-height'),
                        margin = self.attr('data-margin');
                    self.justifiedGallery({
                        rowHeight: rowHeight,
                        maxRowHeight: false,
                        margins: margin,
                    }).on('jg.complete', function (e) {
                        self.addClass('has-init');
                    });
                });
            }
        };

        this.initCarousel = function () {
            if ($.isFunction($.fn.owlCarousel)) {
                $('.fat-maika-listing.owl-carousel').trigger('destroy.owl.carousel');
                $('.fat-maika-listing.owl-carousel').each(function () {
                    var $owl = $(this),
                        defaults = {
                            items: 4,
                            nav: false,
                            navText: ['<i class="fa fa-angle-left"></i> ', ' <i class="fa fa-angle-right"></i>'],
                            dots: false,
                            loop: true,
                            center: false,
                            mouseDrag: true,
                            touchDrag: true,
                            pullDrag: true,
                            freeDrag: false,
                            margin: 0,
                            stagePadding: 0,
                            merge: false,
                            mergeFit: true,
                            autoWidth: false,
                            startPosition: 0,
                            rtl: false,
                            smartSpeed: 250,
                            autoplay: false,
                            autoplayTimeout: 0,
                            fluidSpeed: false,
                            dragEndSpeed: false,
                            autoplayHoverPause: true
                        };
                    var config = $.extend({}, defaults, $owl.data("owl-options"));
                    // Initialize Slider
                    $($owl).imagesLoaded(function () {
                        $owl.owlCarousel(config);
                        var container = $owl.closest('.fat-maika-container');
                        setTimeout(function () {
                            var $cat_active = $('.fat-maika-category-filter a.active');
                            if (typeof $cat_active != 'undefined' && $cat_active.length > 0 && $cat_active.attr('data-category') != 'j1_1') {
                                $cat_active.trigger('click');
                                container.removeClass('has-category-default');
                            } else {
                                container.removeClass('has-category-default');
                            }
                        }, 500);
                    });
                })
            }
        };
    };

    $(document).ready(function () {


        if ($('.fat-maika-container.disable-download').length > 0) {
            $("body").on("contextmenu", function (e) {
                return false;
            });
        }

        $(window).scroll(function () {
            FatMaika.initAppearScroll();
            FatMaika.initInfiniteScroll();
            FatMaika.initJustifiedInfinite();
        });
        $(window).resize(function () {
            setTimeout(function () {
                FatMaika.initAlbumPreview();
                FatMaika.initHorizontalSlide();
            }, 500);
        });

        setTimeout(function () {
            if ($('.fat-maika-category a').length > 0) {
                var match = RegExp('[?&]gallery_cat=([^&]*)').exec(window.location.search),
                    category = match && decodeURIComponent(match[1].replace(/\+/g, ' '));
                if (typeof category != 'undefined' && category != null && category != '') {
                    if ($('.fat-maika-category a[data-category="' + category + '"]').length > 0) {
                        $('.fat-maika-category a[data-category="' + category + '"]').trigger('click');
                    }
                }
            }
        }, 500);

        $('.vc_tta-tabs-list .vc_tta-tab > a').on('click', function () {
            setTimeout(function () {
                FatMaika.init();
            }, 500);
        });

        $('.tours-tabs .nav-tabs a[data-toggle="tab"]').on('click', function () {
            setTimeout(function () {
                FatMaika.init();
            }, 200);
        })
    });

    $(window).on('load',function(){
        FatMaika.init();
    })

    /*$( document ).ajaxComplete(function( event,request, settings ) {
        setTimeout(function(){
            FatMaika.init();
        },200);
    });*/

})(jQuery);