<?php
/**
 * Created by PhpStorm.
 * User: phuongth
 * Date: 8/1/2017
 * Time: 11:08 AM
 */
require_once(ABSPATH . 'wp-admin/includes/file.php');
if(file_exists(FAT_MAIKA_DIR_PATH . '/utils/resize.php')){
    require_once FAT_MAIKA_DIR_PATH . '/utils/resize.php';
}
if (!class_exists('FAT_Maika_Install_Demo')) {
    class FAT_Maika_Install_Demo
    {
        function __construct()
        {
            if (is_admin()) {
                add_action('admin_menu', array($this, 'register_install_demo_page'));
                add_action('admin_enqueue_scripts', array($this, 'enqueue_script'));

                add_action("wp_ajax_fat_import_data", array($this, 'import_data'));
                add_action("wp_ajax_fat_import_image", array($this, 'import_image'));
                if(isset($_GET['action']) && $_GET['action']==='export'){
                    $this->export_data();
                }
            }
        }

        public function enqueue_script()
        {
            wp_enqueue_style('fat-maika-demo', plugins_url('/assets/css/fat-data-demo.css', __FILE__), array(), false);

            wp_register_script('fat-maika-demo', plugins_url('/assets/js/fat-data-demo.js', __FILE__), array('jquery'), '1.0.0 ');
            wp_localize_script('fat-maika-demo', 'fat_ajax', array('ajax_url' => admin_url('admin-ajax.php')));
            wp_enqueue_script('fat-maika-demo');
        }

        public function register_install_demo_page()
        {
            add_submenu_page('edit.php?post_type=fat-maika', 'Install Demo Data', 'Install Demo', 'manage_options', 'maika-install-demo', array($this, 'install_demo_page_callback'));
        }

        public function install_demo_page_callback()
        {
            $template = FAT_MAIKA_DIR_PATH . 'install-demo/install-demo.php';
            if (file_exists($template)) {
                include $template;
            }
        }

        public function export_data()
        {
            global $wpdb;
            $tables = array('posts', 'postmeta');
            $table_data = array();
            $data = '';
            foreach ($tables as $table_name) {
                if ($table_name === 'posts') {
                    $data = $wpdb->get_results("SELECT * FROM $wpdb->prefix$table_name WHERE (post_type !='revision' AND post_status='publish') AND post_type IN('attachment','fat-maika')");
                }else{
                    $data = $wpdb->get_results("SELECT * FROM $wpdb->prefix$table_name");
                }
                $table_data[$table_name] = $data;
            }

            WP_Filesystem();
            global $wp_filesystem;
            $path_export = FAT_MAIKA_DIR_PATH . '/install-demo/data/export-data.json';
            $data_demo = array(
                'domain' => home_url('/'),
                'data'   => $table_data
            );
            $wp_filesystem->put_contents($path_export, json_encode($data_demo), FS_CHMOD_FILE);
        }

        public function import_data()
        {
            WP_Filesystem();
            global $wpdb, $wp_filesystem;
            $tables = array(
                'posts'              => array(
                    'key'    => 'ID',
                ),
                'postmeta'           => array(
                    'key'    => 'meta_id',
                    'parent' => array(
                        'table'      => 'posts',
                        'parent_key' => 'ID',
                        'child_key'  => 'post_id'
                    )
                ),
            );

            $meta_keys = array('_thumbnail_id');

            $table_new_key = get_option('fat_import_table_new_key', null);
            $table_attachment = get_option('fat_import_attachment', array());

            if ($table_new_key == null || !is_array($table_new_key)) {
                $table_new_key = array(
                    'posts'              => array(),
                    'postmeta'           => array(),
                );
            }

            $data_file = isset($_POST['data_file']) && $_POST['data_file'] !== '' ? $_POST['data_file'] : '';
            if ($data_file !== '') {
                $table_name = isset($_POST['table_name']) && $_POST['table_name'] !== '' ? $_POST['table_name'] : '';
                $start = isset($_POST['start']) && $_POST['start'] !== '' ? $_POST['start'] : 0;
                $batch = isset($_POST['batch']) && $_POST['batch'] !== '' ? $_POST['batch'] : 10;
                $total_done = isset($_POST['total_done']) && $_POST['total_done'] !== '' ? $_POST['total_done'] : 0;

                $data_import = $wp_filesystem->get_contents(FAT_MAIKA_DIR_PATH . '/install-demo/data/' . $data_file);
                $resources_path = dirname(FAT_MAIKA_DIR_PATH . '/install-demo/data/' . $data_file). '/uploads';
                $resources_file = '';

                $data_import = json_decode($data_import, true);
                $from_domain = $data_import['domain'];
                $domain = home_url('/');
                $data_import = $data_import['data'];

                if($table_name === ''){
                    $table_name = array_keys($tables);
                    $table_name = $table_name[0];
                }

                $table_schema = isset($tables[$table_name]) ? $tables[$table_name] : array();
                $table_data = isset($data_import[$table_name]) ? $data_import[$table_name] : array();
                $total_row = count($table_data);
                $end = $total_row > ($start + $batch) ? ($start + $batch) : $total_row;
                $attachment_url = $file_name = $upload = $header = $body = '';

                $total_post = 0;
                foreach ($tables as $tb_name => $tb_value) {
                    $total_post += count($data_import[$tb_name]);
                }

                if ($total_done >= $total_post) {
                    $result = array(
                        'total'       => $total_post,
                        'count'       => 0,
                        'start'       => 0,
                        'table_name'  => $table_name,
                        'is_finished' => 1
                    );

                    /*$this->syn_page_template($table_new_key);
                    $this->syn_terms_and_post_parent($table_new_key);*/
                    delete_option('fat_import_table_new_key');
                    echo json_encode($result);
                    wp_die();
                }

                $count = 0;
                $new_id = $key_name = $key_value = $parent_key = $child_key = $child_value = $parent_table = '';
                $sql_query = $result_query = $galleries = $fat_mb_image_gallery = '';

                for ($i = $start; $i < $end; $i++) {

                    //remove primary key
                    $key_name = isset($table_schema['key']) ? $table_schema['key'] : '';
                    if ($key_name!=='' && isset($table_data[$i][$key_name])) {
                        $key_value = $table_data[$i][$key_name];
                        $table_new_key[$table_name][$key_value] = $key_value;
                        if (isset($table_data[$i]['post_type']) && $table_data[$i]['post_type'] === 'attachment') {
                            $table_attachment[$key_value] = $key_value;
                        }
                        unset($table_data[$i][$key_name]);
                    }

                    //update new key
                    if (isset($table_schema['parent'])) {
                        $parent_table = $table_schema['parent']['table'];
                        $parent_key = $table_schema['parent']['parent_key'];
                        $child_key = $table_schema['parent']['child_key'];
                        $child_value = isset($table_data[$i][$child_key]) ? $table_data[$i][$child_key] : 0;
                        if (isset($table_data[$i][$child_key]) && isset($table_new_key[$parent_table][$child_value])) {
                            $table_data[$i][$child_key] = $table_new_key[$parent_table][$child_value];
                        }

                        if ($table_name === 'postmeta') {
                            if (isset($table_data[$i]['meta_key']) && in_array($table_data[$i]['meta_key'], $meta_keys)
                                && isset($table_data[$i]['meta_value']) && isset($table_attachment[$table_data[$i]['meta_value']])
                            ) {
                                $table_data[$i]['meta_value'] = $table_attachment[$table_data[$i]['meta_value']];
                            }

                            //update image for portfolio gallery meta box
                            if( ($table_data[$i]['meta_key']) == 'fat-meta-box-gallery-type' ){
                                $galleries = unserialize($table_data[$i]['meta_value']);
                                if(isset($galleries['fat_mb_image_gallery']) && $galleries['fat_mb_image_gallery']!==''){
                                    $fat_mb_image_gallery = explode(',', $galleries['fat_mb_image_gallery']);
                                    $total = count($fat_mb_image_gallery);
                                    for($j=0; $j<$total;$j++){
                                        if(isset($table_attachment[$fat_mb_image_gallery[$j]])){
                                            $fat_mb_image_gallery[$j] = $table_attachment[$fat_mb_image_gallery[$j]];
                                        }
                                    }
                                    $galleries['fat_mb_image_gallery'] = implode(',', $fat_mb_image_gallery);
                                    $table_data[$i]['meta_value'] = serialize($galleries);
                                }
                            }
                        }
                    }

                    if (isset($table_data[$i]['post_type']) && $table_data[$i]['post_type'] === 'attachment') {
                        $attachment_url = $table_data[$i]['guid'];
                        $file_name = wp_basename($attachment_url);

                        $existing_upload = wp_upload_dir($table_data[$i]['post_date']);
                        $existing_upload['file'] = $existing_upload['path'] . "/$file_name";
                        $existing_upload['url'] = $existing_upload['url'] . "/$file_name";
                        $resources_file = $resources_path. $existing_upload['subdir'].  "/$file_name";

                        if ( !is_dir($resources_path) && !file_exists($resources_file) && !file_exists($existing_upload['file'])) {
                            $response = wp_remote_get($attachment_url, array('timeout' => 60, 'httpversion' => '1.1'));
                            if (isset($response) && is_array($response)) {
                                $header = $response['headers'];
                                $body = $response['body'];
                                $wp_filesystem->put_contents($existing_upload['file'], $body, FS_CHMOD_FILE);
                            }
                        }else{
                            copy( $resources_file, $existing_upload['file'] );
                        }

                        if (isset($table_data[$i]['guid'])) {
                            $table_data[$i]['guid'] = str_replace($from_domain, $domain, $table_data[$i]['guid']);
                        }
                        $wpdb->insert("$wpdb->prefix$table_name", $table_data[$i]);
                        $new_id = $wpdb->insert_id;
                        $table_new_key[$table_name][$key_value] = $new_id;
                        if (isset($table_attachment[$key_value])) {
                            $table_attachment[$key_value] = $new_id;
                        }

                    } else {
                        $wpdb->insert("$wpdb->prefix$table_name", $table_data[$i]);
                        $new_id = $wpdb->insert_id;
                        $table_new_key[$table_name][$key_value] = $new_id;
                    }
                    $count++;
                }

                $result = array(
                    'total'       => $total_post,
                    'count'       => $count,
                    'start'       => $start + $count,
                    'table_name'  => $table_name,
                    'is_finished' => 0
                );

                update_option('fat_import_attachment', $table_attachment);
                update_option('fat_import_table_new_key', $table_new_key);

                if ($total_row <= ($start + $count)) {
                    $table_index = array_search($table_name, array_keys($tables));
                    if ($table_index === count($tables)) {
                        $result['is_finished'] = 1;

                        $this->syn_page_template($table_new_key);
                        $this->syn_terms_and_post_parent($table_new_key);
                        delete_option('fat_import_table_new_key');

                    } else {
                        $tb = array_keys($tables);
                        $result['table_name'] = '';
                        if(isset($tb[$table_index + 1])){
                            $result['table_name'] = $tb[$table_index + 1];
                        }
                        $result['start'] = 0;
                    }
                }
                echo json_encode($result);
                wp_die();
            }
        }

        public function import_image(){
            $table_attachment = get_option('fat_import_attachment', array());

            $start = isset($_POST['start']) && $_POST['start'] !== '' ? $_POST['start'] : 0;
            $batch = isset($_POST['batch']) && $_POST['batch'] !== '' ? $_POST['batch'] : 20;
            $is_finished = $counter = 0;

            if(is_array($table_attachment) && function_exists('fat_maika_matthewruddy_image_resize_id')){
                $attachments = array_values($table_attachment);
                $total = count($attachments);
                for($i=$start; $i < $total; $i++){
                    $attachment_meta_data = wp_get_attachment_metadata($attachments[$i]);
                    //thumbnail

                    $width = isset($attachment_meta_data['sizes']['thumbnail']['width']) ? $attachment_meta_data['sizes']['thumbnail']['width'] : 0;
                    $height = isset($attachment_meta_data['sizes']['thumbnail']['height']) ? $attachment_meta_data['sizes']['thumbnail']['height'] : 0;
                    if($width > 0 && $height > 0){
                        fat_maika_matthewruddy_image_resize_id($attachments[$i], $width, $height);
                    }

                    //medium
                    $width = isset($attachment_meta_data['sizes']['medium']['width']) ? $attachment_meta_data['sizes']['medium']['width'] : 0;
                    $height = isset($attachment_meta_data['sizes']['medium']['height']) ? $attachment_meta_data['sizes']['medium']['height'] : 0;
                    if($width > 0 && $height > 0){
                        fat_maika_matthewruddy_image_resize_id($attachments[$i], $width, $height);
                    }

                    //large
                    $width = isset($attachment_meta_data['sizes']['large']['width']) ? $attachment_meta_data['sizes']['large']['width'] : 0;
                    $height = isset($attachment_meta_data['sizes']['large']['height']) ? $attachment_meta_data['sizes']['large']['height'] : 0;
                    if($width > 0 && $height > 0){
                        fat_maika_matthewruddy_image_resize_id($attachments[$i], $width, $height);
                    }

                    // feature image
                    fat_maika_matthewruddy_image_resize_id($attachments[$i], 375, 375);

                    $counter++;
                }
                $start += $counter;
            }
            if($start >= $total || !is_array($table_attachment)){
                $is_finished = 1;
                delete_option('fat_import_attachment');
            }
            $result = array(
                'start'       => $start,
                'is_finished' => $is_finished
            );
            echo json_encode($result);
            wp_die();

        }
    }

    if (is_admin()) {
        new FAT_Maika_Install_Demo();
    }
}