var FatCmbCategoryImage = FatCmbCategoryImage || {};

jQuery(function ($) {
    'use strict';
    FatCmbCategoryImage = {

        setFatCmbCategoryImageSortable: function () {
            if ($.isFunction($.fn.sortable)) {
                $('.fat-list-image').sortable({
                    delay: 100,
                    update: function () {
                        var input_id = $(this).attr('data-input-id'),
                            parent = $(this).closest('.fat-add-image-wrap');
                        FatCmbCategoryImage.setFatCmbCategoryImageId(parent, input_id);
                    }
                });
            }
        },

        setFatCmbCategoryImageId: function ($container, input_id) {
            var jtree_cat = $('.fat-category-list .fat-jtree-category', $container),
                hf_input = $('input[type="hidden"]', $container),
                js_category_image = hf_input.val(),
                cat_id = jtree_cat.jstree('get_selected'),
                ids = [],
                img_id = '',
                url = '',
                title = '',
                desc = '',
                link = '',
                video_embed = '';

            if (typeof js_category_image == 'undefined' || js_category_image === '') {
                js_category_image = [];
            } else {
                js_category_image = $.parseJSON(js_category_image);
            }

            if (typeof cat_id !== 'undefined' && cat_id.length > 0) {
                cat_id = cat_id[0];
            } else {
                cat_id = 0;
            }

            if (typeof FatCmbCategoryImage.arr_imgs === 'undefined') {
                FatCmbCategoryImage.arr_imgs = {};
            }

            $('.fat-image-thumb', $container).each(function () {
                img_id = $(this).attr('data-id');
                url = $('img', this).attr('src');
                if (typeof FatCmbCategoryImage.arr_imgs[cat_id + '_' + img_id] !== 'undefined') {
                    title = FatCmbCategoryImage.arr_imgs[cat_id + '_' + img_id].title;
                    desc = FatCmbCategoryImage.arr_imgs[cat_id + '_' + img_id].description;
                    link = FatCmbCategoryImage.arr_imgs[cat_id + '_' + img_id].link;
                    video_embed = FatCmbCategoryImage.arr_imgs[cat_id + '_' + img_id].video_embed;
                } else {
                    title = link = video_embed = desc = '';
                }
                if (typeof fat_data.upload_dir !== 'undefined' && typeof fat_data.upload_dir.baseurl !== 'undefined' && fat_data.upload_dir.baseurl !== '') {
                    url = url.replace(fat_data.upload_dir.baseurl, '');
                }
                ids.push({
                    'id': img_id,
                    'url': url,
                    'title': title,
                    'description': desc,
                    'link': link,
                    'video_embed': video_embed
                });
            });

            for (var $i = 0; $i < js_category_image.length; $i++) {
                if (js_category_image[$i].id == cat_id) {
                    js_category_image[$i]['imgs'] = ids;
                }
            }
            hf_input.val(JSON.stringify(js_category_image));
        },

        setFatCmbCategoryImageEdit: function () {
            $('a.fat-edit-image', '.fat-cmb-images-wrap').off('click').on('click', function (event) {
                var self = $(this),
                    container = self.closest('.fat-cmb-images-wrap.category-image-wrap'),
                    list_image = $('.fat-list-image', container),
                    cat_id_selected = list_image.attr('data-cat-id'),
                    list_image_wrap = $('.fat-list-image-wrap', container),
                    image_id = self.attr('data-id'),
                    thumb = $('div[data-id="' + image_id + '"]', container),
                    form_edit = $('.fat-cmb-category-edit.fat-form-template', container).clone().removeClass('fat-form-template'),
                    index = 1,
                    item_per_row = 5,
                    find_thumb = false,
                    is_append = false,
                    total_thumb = $('.fat-image-thumb', list_image).length,
                    delay_slide = 0;

                event.preventDefault();

                if (thumb.hasClass('editing')) {
                    FatCmbCategoryImage.removeEditForm(container, true);
                    return;
                }

                var list_image_width = list_image_wrap.width(),
                    thumb_width = thumb.width();
                item_per_row = parseInt(list_image_width / thumb_width);
                $('.fat-image-thumb', list_image).removeClass('editing');


                delay_slide = $('.fat-list-image-wrap .fat-cmb-category-edit', container).length > 0 ? 500 : 0;
                $('.fat-list-image-wrap .fat-cmb-category-edit', container).slideUp(function () {
                    $('.fat-list-image-wrap .fat-cmb-category-edit', container).remove();
                });


                if (typeof FatCmbCategoryImage.arr_imgs === 'undefined' || FatCmbCategoryImage.arr_imgs.length == 0 || typeof FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id] === 'undefined') {
                    return;
                }

                setTimeout(function () {
                    $('.fat-cmb-image-title', form_edit).val(FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].title);
                    $('.fat-cmb-image-description', form_edit).val(FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].description);
                    $('.fat-cmb-image-video-embed', form_edit).val(FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].video_embed);
                    $('.fat-cmb-image-link', form_edit).val(FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].link);
                    form_edit.attr('data-img-id', image_id);

                    if (total_thumb <= item_per_row) {
                        $('.fat-list-image', list_image_wrap).append(form_edit);
                    } else {
                        $('.fat-image-thumb', list_image).each(function () {
                            if ($(this).attr('data-id') == image_id) {
                                find_thumb = true;
                            }
                            if ((index % item_per_row == 0 && find_thumb) || (total_thumb == index && !is_append)) {
                                $(this).after(form_edit);
                                is_append = true;
                                return false;
                            }
                            index++;
                        });
                    }

                    form_edit.removeClass('hidden').css('display', 'none');
                    thumb.addClass('editing');
                    form_edit.slideDown(function () {
                        $('.fat-cmb-image-title', form_edit).focus();
                    });

                    $('input.fat-cmb-image-save', form_edit).on('click', function () {
                        FatCmbCategoryImage.updateImageInfo(this, cat_id_selected, image_id, form_edit);
                        FatCmbCategoryImage.removeEditForm(container, true);
                    });

                    $('input.fat-cmb-image-cancel', form_edit).on('click', function () {
                        FatCmbCategoryImage.removeEditForm(container, true);
                    });
                }, delay_slide);

            });
        },

        showToolTip : function(){
            $('.fat-list-image-wrap .fat-image-thumb').off('mouseover').on('mouseover',function(){
                var container = $(this).closest('.fat-list-image-wrap'),
                    image_id = $('.fat-edit-image', this).attr('data-id'),
                    cat_id_selected = $('.fat-list-image',container).attr('data-cat-id'),
                    tooltip = '';

                tooltip += 'Title: ' + FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].title;
                if(FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].description!=''){
                    tooltip += '<br/>Description: ' + FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].description;
                }
                if(FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].link!=''){
                    tooltip += '<br/>Link: ' + FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].link;
                }
                if(FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].video_embed!=''){
                    tooltip += '<br/>Video Embbed: ' + FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].video_embed;
                }

                $(this).tooltipster({
                    contentAsHTML: true,
                    delay: 100
                }).tooltipster('content', tooltip).tooltipster('open');
            });
        },

        registerAddFatCmbCategoryImage: function () {
            $('a.fat-add-image', '.fat-cmb-images-wrap').off('click').on('click', function (event) {
                var container = $(this).closest('.fat-cmb-images-wrap.category-image-wrap'),
                    cat_id_selected = $('.fat-list-image-wrap .fat-list-image', container).attr('data-cat-id');
                event.preventDefault();

                //remove edit form
                FatCmbCategoryImage.removeEditForm(container);

                // check for media manager instance
                /* if (wp.media.frames.gk_frame) {
                     wp.media.frames.gk_frame.multiple = true;
                     wp.media.frames.gk_frame.open();
                     wp.media.frames.gk_frame.clicked_button = $(this);
                     return;
                 }*/

                wp.media.frames.gk_frame = wp.media({
                    title: 'Select Image',
                    multiple: true,
                    library: {
                        type: 'image'
                    }
                });
                wp.media.frames.gk_frame.clicked_button = $(this);
                wp.media.frames.gk_frame.open().on('select', function (e) {
                    var img_url,
                        img_full_url,
                        img_id,
                        parent,
                        image,
                        input_id,
                        title,
                        desc,
                        selection_image = wp.media.frames.gk_frame.state().get('selection');

                    input_id = $(wp.media.frames.gk_frame.clicked_button).attr('data-input-id');
                    selection_image.each(function (attachment) {
                        image = '<div class="fat-image-thumb" data-id="%id" ><img src="%thumbnail" onerror="this.src=' + attachment.attributes.url + '" /><div class="fat-overlay fat-transition-30"><span><a class="fat-edit-image" title="Edit image information" data-id="%id" href="javascript:void(0)"><i class="dashicons dashicons-edit"></i></a></span><span><a class="fat-delete-image" data-id="%id" href="javascript:;" title="Delete image"><i class="dashicons dashicons-no-alt"></i></a></span></div></div>';
                        if (typeof attachment.attributes.sizes.thumbnail != 'undefined') {
                            img_url = attachment.attributes.sizes.thumbnail.url;
                        } else {
                            var type = attachment.attributes.mime.split('/')[1];
                            var arr_url = attachment.attributes.url.split('.' + type);
                            img_url = arr_url[0] + '-150x150.' + type;
                        }
                        title = typeof attachment.attributes.title != 'undefined' ? attachment.attributes.title : '';
                        desc = typeof attachment.attributes.description != 'undefined' ? attachment.attributes.description : '';
                        img_id = attachment.attributes.id;
                        parent = $(wp.media.frames.gk_frame.clicked_button).closest('.fat-add-image-wrap');
                        image = image.replace("%thumbnail", img_url);
                        image = image.replace(/%id/g, img_id);
                        if (typeof FatCmbCategoryImage.arr_imgs === 'undefined') {
                            FatCmbCategoryImage.arr_imgs = {};
                        }
                        FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + img_id] = {
                            'title': title,
                            'description': desc,
                            'link': '',
                            'video_embed': ''
                        };

                        if ($('[data-id="' + img_id + '"]', parent).length <= 0) {
                            $('.fat-list-image', parent).append(image);
                        }

                    });
                    FatCmbCategoryImage.setFatCmbCategoryImageSortable();
                    FatCmbCategoryImage.registerDeleteFatCmbCategoryImage();
                    FatCmbCategoryImage.setFatCmbCategoryImageEdit();
                    FatCmbCategoryImage.setFatCmbCategoryImageId(parent, input_id);
                    FatCmbCategoryImage.showToolTip();
                });
            })
        },

        registerDeleteFatCmbCategoryImage: function () {
            var $image_id = 0,
                $container,
                input_id;
            $('a.fat-delete-image', '.fat-cmb-images-wrap.category-image-wrap').each(function () {
                $container = $(this).closest('.fat-cmb-images-wrap.category-image-wrap');
                $(this).off('click').on('click', function () {
                    $image_id = $(this).attr('data-id');
                    input_id = $(this).closest('.fat-list-image').attr('data-input-id');
                    if($.isFunction($.confirm)){
                        $.confirm({
                            title: 'Confirm delete!',
                            content: 'Please confirm delete this image!',
                            buttons: {
                                confirm: function () {
                                    $('.fat-image-thumb[data-id="' + $image_id + '"]', $container).remove();
                                    FatCmbCategoryImage.setFatCmbCategoryImageId($container, input_id);
                                },
                                cancel: function () {
                                },
                            }
                        });
                    }else{
                        $('.fat-image-thumb[data-id="' + $image_id + '"]', $container).remove();
                        FatCmbCategoryImage.setFatCmbCategoryImageId($container, input_id);
                    }

                });
            });
        },

        initJTreeCategory: function () {
            $('.fat-category-list .fat-jtree-category').each(function () {
                var self = $(this),
                    container = self.closest('.fat-cmb-images-wrap.category-image-wrap'),
                    hf_input = $('input[type="hidden"]', container),
                    js_category_image = hf_input.val();

                if (typeof js_category_image == 'undefined' || js_category_image === '') {
                    js_category_image = [{
                        'id': 'j1_1',
                        'text': 'Category',
                        'parent': '#',
                        'state': {'opened': true, 'selected': true}
                    }];
                    hf_input.val(JSON.stringify(js_category_image));
                } else {
                    js_category_image = $.parseJSON(js_category_image);
                }

                js_category_image = FatCmbCategoryImage.sortByKey(js_category_image, 'order');
                self.jstree({
                    "core": {
                        "multiple": false,
                        "check_callback": function (operation, node, node_parent, node_position, more) {
                            // operation can be 'create_node', 'rename_node', 'delete_node', 'move_node', 'copy_node' or 'edit'
                            // in case of 'rename_node' node_position is filled with the new node name
                            if (operation === 'delete_node') {
                                var confirm = window.confirm("Press OK button to confirm delete category. Cancel to leave!");
                                return confirm;
                            }
                            if (operation === 'move_node') {
                                if (typeof node_parent.parent == 'undefined' || node_parent.parent == null) {
                                    return false;
                                }
                            }
                            return true;
                        },
                        'data': js_category_image
                    },
                    "contextmenu": {
                        "items": function ($node) {
                            var tree = self.jstree(true);
                            return {
                                "Create": {
                                    "separator_before": false,
                                    "separator_after": false,
                                    "label": "Create",
                                    "action": function (obj) {
                                        $node = tree.create_node($node);
                                        tree.edit($node);
                                    }
                                },
                                "Rename": {
                                    "separator_before": false,
                                    "separator_after": false,
                                    "label": "Rename",
                                    "action": function (obj) {
                                        tree.edit($node);
                                    }
                                },
                                "Edit Infor": {
                                    "separator_before": false,
                                    "separator_after": false,
                                    "label": "Edit information",
                                    "action": function (obj) {
                                        FatCmbCategoryImage.editCategoryInfo(obj.reference[0], $node);
                                    }
                                },
                                "Set Default": {
                                    "separator_before": false,
                                    "separator_after": false,
                                    "label": "Set as default filter",
                                    "action": function (obj) {
                                        FatCmbCategoryImage.setCategoryDefault(obj.reference[0], $node);
                                    }
                                },
                                "Delete": {
                                    "separator_before": false,
                                    "separator_after": false,
                                    "label": "Delete",
                                    "action": function (obj) {
                                        tree.delete_node($node);
                                    }
                                }
                            };
                        }
                    },
                    "plugins": ["contextmenu", "dnd"]
                });
            });

            //create node
            $('.fat-category-list .fat-jtree-category').on('create_node.jstree', function (e, data) {
                var self = $(this),
                    container = self.closest('.fat-cmb-images-wrap.category-image-wrap'),
                    hf_input = $('input[type="hidden"]', container),
                    js_category_image = hf_input.val();

                if (typeof js_category_image == 'undefined' || js_category_image === '') {
                    js_category_image = [];
                } else {
                    js_category_image = $.parseJSON(js_category_image);
                }

                for (var $i = 0; $i < js_category_image.length; $i++) {
                    js_category_image[$i].state.selected = false;
                }
                js_category_image.push({
                    'id': data.node.id,
                    'text': data.node.text,
                    'caption': '',
                    'description': '',
                    'link': '',
                    'parent': data.parent,
                    'state': {'opened': false, 'selected': true},
                    'order': data.position
                });
                self.jstree('deselect_all');
                self.jstree('select_node', data.node.id);
                hf_input.val(JSON.stringify(js_category_image));


            });

            //rename node
            $('.fat-category-list .fat-jtree-category').on('rename_node.jstree', function (e, data) {
                var obj = FatCmbCategoryImage.getFatJTreeData(this),
                    container = obj.container,
                    hf_input = obj.hf_input,
                    js_category_image = obj.js_category_image;

                for (var $i = 0; $i < js_category_image.length; $i++) {
                    if (js_category_image[$i].id == data.node.id) {
                        js_category_image[$i].text = data.text;
                        break;
                    }
                }
                hf_input.val(JSON.stringify(js_category_image));
            });

            //delete node
            $('.fat-category-list .fat-jtree-category').on('delete_node.jstree', function (e, data) {
                var obj = FatCmbCategoryImage.getFatJTreeData(this),
                    container = obj.container,
                    hf_input = obj.hf_input,
                    js_category_image = obj.js_category_image,
                    parent = '';

                for (var $i = 0; $i < js_category_image.length; $i++) {
                    if (js_category_image[$i].id == data.node.id) {
                        parent = js_category_image[$i].parent;
                        js_category_image.splice($i, 1);
                        //delete sub cat
                        js_category_image = FatCmbCategoryImage.deleteSubCat(js_category_image,data.node.id);

                        break;
                    }
                }

                hf_input.val(JSON.stringify(js_category_image));
                if (parent !== '') {
                    $(this).jstree('select_node', parent);
                }
            });

            //change node
            $('.fat-category-list .fat-jtree-category').on('changed.jstree', function (e, data) {
                var container = $(this).closest('.fat-cmb-images-wrap.category-image-wrap'),
                    cat_id_selected = data.selected,
                    list_image = $('.fat-list-image-wrap .fat-list-image', container),
                    current_cat_id = list_image.attr('data-cat-id'),
                    image = '',
                    cat_item = [];

                //remove edit form
                FatCmbCategoryImage.removeEditForm(container);

                cat_id_selected = typeof cat_id_selected !== 'undefined' && cat_id_selected.length > 0 ? cat_id_selected[0] : '';
                if (cat_id_selected == '' || typeof cat_id_selected == 'undefined' || current_cat_id == cat_id_selected) {
                    return;
                }

                list_image.fadeOut(function () {
                    var obj = FatCmbCategoryImage.getFatJTreeData(this),
                        hf_input = obj.hf_input,
                        js_category_image = obj.js_category_image;

                    list_image.empty();
                    list_image.attr('data-cat-id', cat_id_selected);
                    for (var $i = 0; $i < js_category_image.length; $i++) {
                        js_category_image[$i].state.selected = false;
                        if (js_category_image[$i].id == cat_id_selected) {
                            js_category_image[$i].state.selected = true;
                            cat_item = js_category_image[$i];
                            list_image.fadeOut(function () {
                                list_image.empty();
                                if (typeof cat_item.imgs !== 'undefined' && cat_item.imgs.length > 0) {
                                    for (var $j = 0; $j < cat_item.imgs.length; $j++) {
                                        if (typeof fat_data.upload_dir !== 'undefined' && typeof fat_data.upload_dir.baseurl !== 'undefined' && fat_data.upload_dir.baseurl !== '') {
                                            cat_item.imgs[$j].url = fat_data.upload_dir.baseurl + cat_item.imgs[$j].url;
                                        }
                                        image = '<div class="fat-image-thumb" data-id="%id" ><img src="%thumbnail" onerror="%on_error" />' +
                                            '<div class="fat-overlay fat-transition-30">' +
                                            '<span><a class="fat-edit-image" data-id="%id" title="Edit image information" href="javascript:void(0)">' +
                                            '<i class="dashicons dashicons-edit"></i>' +
                                            '</a></span>' +
                                            '<span><a class="fat-delete-image" data-id="%id" title="Delete image" href="javascript:void(0);"><i class="dashicons dashicons-no-alt"></i></a></span>' +
                                            '</div>' +
                                            '</div>';

                                        var lastDotIndex = cat_item.imgs[$j].url.lastIndexOf("."),
                                            firstUrl = cat_item.imgs[$j].url.substr(0,lastDotIndex),
                                            url = cat_item.imgs[$j].url;

                                        /*if(url.lastIndexOf("-150x150") != (firstUrl.length - 8)){
                                            url = firstUrl + '-150x150' + cat_item.imgs[$j].url.substr(lastDotIndex);
                                        }*/

                                        image = image.replace("%thumbnail", url);
                                        image = image.replace("%on_error", cat_item.imgs[$j].url);
                                        image = image.replace(/%id/g, cat_item.imgs[$j].id);
                                        list_image.append(image);
                                        if (typeof FatCmbCategoryImage.arr_imgs === 'undefined') {
                                            FatCmbCategoryImage.arr_imgs = {};
                                        }
                                        FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + cat_item.imgs[$j].id] = {
                                            'title': cat_item.imgs[$j].title,
                                            'description': cat_item.imgs[$j].description,
                                            'link': cat_item.imgs[$j].link,
                                            'video_embed': cat_item.imgs[$j].video_embed,
                                        };
                                    }
                                }
                            });
                        }
                    }

                    //update node selected into hidden field
                    hf_input.val(JSON.stringify(js_category_image));
                    list_image.fadeIn(function () {
                        FatCmbCategoryImage.registerDeleteFatCmbCategoryImage();
                        FatCmbCategoryImage.setFatCmbCategoryImageEdit();
                        FatCmbCategoryImage.showToolTip();
                    });
                });

            });

            //move node
            $('.fat-category-list .fat-jtree-category').on('move_node.jstree', function (e, data) {
                var obj = FatCmbCategoryImage.getFatJTreeData(this),
                    container = obj.container,
                    hf_input = obj.hf_input,
                    js_category_image = obj.js_category_image;

                for (var $i = 0; $i < js_category_image.length; $i++) {
                    if (js_category_image[$i].id == data.node.id) {
                        js_category_image[$i].parent = data.parent;
                        js_category_image[$i].order = data.position;
                        break;
                    }
                }
                //reorder
                var $new_parent_child = $('.fat-category-list .fat-jtree-category', container).jstree('get_children_dom', data.parent),
                    $old_parent_child,
                    id = '';
                for (var $i = 0; $i < $new_parent_child.length; $i++) {
                    id = $($new_parent_child[$i]).attr('id');
                    for (var $j = 0; $j < js_category_image.length; $j++) {
                        if (js_category_image[$j].id == id) {
                            js_category_image[$j].order = $i;
                        }
                    }
                }
                if (data.old_parent != data.parent) {
                    $old_parent_child = $('.fat-category-list .fat-jtree-category', container).jstree('get_children_dom', data.old_parent);
                    for (var $i = 0; $i < $old_parent_child.length; $i++) {
                        id = $($old_parent_child[$i]).attr('id');
                        for (var $j = 0; $j < js_category_image.length; $j++) {
                            if (js_category_image[$j].id == id) {
                                js_category_image[$j].order = $i;
                            }
                        }
                    }
                }
                hf_input.val(JSON.stringify(js_category_image));
            });
        },

        deleteSubCat: function(js_category_image, cat_id){
            var $arr_id = [];
            var $result = [];
            for(var $i=0;$i< js_category_image.length; $i++){
                if (typeof (js_category_image[$i].parent) !='undefined' &&  js_category_image[$i].parent == cat_id) {
                    $arr_id.push(js_category_image[$i].id);
                }else{
                    $result.push(js_category_image[$i]);
                }
            }
            if($arr_id.length>0){
                for(var $i=0; $i< $arr_id.length; $i++){
                    $result = FatCmbCategoryImage.deleteSubCat($result,$arr_id[$i]);
                }
            }
            return $result;
        },

        editCategoryInfo: function (elm, node) {
            var $popup = $('<div class="fat-cmb-popup-wrap"></div>'),
                container = elm.closest('.fat-cmb-images-wrap.category-image-wrap'),
                hf_input = $('input[type="hidden"]', container),
                js_category_image = hf_input.val();
            $popup.append($('.fat-cmb-cat-info-inner').clone());

            js_category_image = $.parseJSON(js_category_image);
            for (var $i = 0; $i < js_category_image.length; $i++) {
                if (js_category_image[$i].id == node.id) {
                    $('.fat-cmb-cat-id',$popup).html(js_category_image[$i].id);
                    $('.fat-cmb-cat-title', $popup).val(js_category_image[$i].text);
                    if (typeof js_category_image[$i].caption != 'undefined') {
                        $('.fat-cmb-cat-caption', $popup).val(js_category_image[$i].caption);
                    }
                    if (typeof js_category_image[$i].description != 'undefined') {
                        $('.fat-cmb-cat-description', $popup).val(js_category_image[$i].description);
                    }
                    break;
                }
            }

            $('body').append($popup);
            $('body').trigger('append_popup');

            $('body .fat-cmb-popup-wrap').fadeIn(function () {

                $('.fat-cmb-popup-wrap a.fat-cmb-close-popup').on('click', function () {
                    $('body .fat-cmb-popup-wrap').fadeOut(function () {
                        $('body .fat-cmb-popup-wrap').remove();
                    });
                });

                $('.fat-cmb-popup-wrap .fat-cmb-cat-cancel').on('click', function () {
                    $('body .fat-cmb-popup-wrap').fadeOut(function () {
                        $('body .fat-cmb-popup-wrap').remove();
                    });
                });

                $('.fat-cmb-popup-wrap .fat-cmb-cat-save').on('click', function () {
                    for (var $i = 0; $i < js_category_image.length; $i++) {
                        if (js_category_image[$i].id == node.id) {
                            js_category_image[$i].caption = $('.fat-cmb-cat-caption', $popup).val();
                            js_category_image[$i].description = $('.fat-cmb-cat-description', $popup).val();
                            js_category_image[$i].link = $('.fat-cmb-cat-link', $popup).val();
                            hf_input.val(JSON.stringify(js_category_image));
                            break;
                        }
                    }
                    $('body .fat-cmb-popup-wrap').fadeOut(function () {
                        $('body .fat-cmb-popup-wrap').remove();
                    });
                });
            });
        },

        setCategoryDefault: function(elm, node){
            var container = elm.closest('.fat-cmb-images-wrap.category-image-wrap'),
                hf_input = $('input[type="hidden"]', container),
                js_category_image = hf_input.val();

            js_category_image = $.parseJSON(js_category_image);
            for (var $i = 0; $i < js_category_image.length; $i++) {
                if (js_category_image[$i].id == node.id) {
                    js_category_image[$i].is_default = 1;
                }else{
                    js_category_image[$i].is_default = 0;
                }
            }

            hf_input.val(JSON.stringify(js_category_image));
            FatCmbCategoryImage.showNotify('"' + node.text + '" have been set default filter');
        },

        removeEditForm: function ($container, $animation) {
            $('.fat-image-thumb', $container).removeClass('editing');
            if (typeof $animation !== 'undefined' && $animation) {
                $('.fat-list-image-wrap .fat-cmb-category-edit', $container).slideUp(function () {
                    $('.fat-list-image-wrap .fat-cmb-category-edit', $container).remove();
                })
            } else {
                $('.fat-list-image-wrap .fat-cmb-category-edit', $container).remove();
            }
        },

        updateImageInfo: function (elm, cat_id_selected, image_id, form_edit) {
            var title = $('.fat-cmb-image-title', form_edit).val(),
                description = $('.fat-cmb-image-description', form_edit).val(),
                video_embed = $('.fat-cmb-image-video-embed', form_edit).val(),
                link = $('.fat-cmb-image-link', form_edit).val();

            if (typeof FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id] !== 'undefined') {
                FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].title = title;
                FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].description = description;
                FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].video_embed = video_embed;
                FatCmbCategoryImage.arr_imgs[cat_id_selected + '_' + image_id].link = link;
            }
            var obj = FatCmbCategoryImage.getFatJTreeData(elm);
            for (var $i = 0; $i < obj.js_category_image.length; $i++) {
                if (obj.js_category_image[$i].id == cat_id_selected) {
                    for (var $j = 0; $j < obj.js_category_image[$i].imgs.length; $j++) {
                        if (obj.js_category_image[$i].imgs[$j].id == image_id) {
                            obj.js_category_image[$i].imgs[$j].title = title;
                            obj.js_category_image[$i].imgs[$j].description = description;
                            obj.js_category_image[$i].imgs[$j].video_embed = video_embed;
                            obj.js_category_image[$i].imgs[$j].link = link;
                            break;
                        }
                    }
                    break;
                }
            }
            obj.hf_input.val(JSON.stringify(obj.js_category_image));
        },

        getFatJTreeData: function (elm) {
            var container = $(elm).closest('.fat-cmb-images-wrap.category-image-wrap'),
                hf_input = $('input[type="hidden"]', container),
                js_category_image = hf_input.val();

            if (typeof js_category_image == 'undefined' || js_category_image === '') {
                js_category_image = [];
            } else {
                js_category_image = $.parseJSON(js_category_image);
            }
            return {'container': container, 'hf_input': hf_input, 'js_category_image': js_category_image};
        },

        sortByKey: function (array, key) {
            return array.sort(function (a, b) {
                var x = a[key];
                var y = b[key];

                if (typeof x == "string") {
                    x = x.toLowerCase();
                }
                if (typeof y == "string") {
                    y = y.toLowerCase();
                }

                return ((x < y) ? -1 : ((x > y) ? 1 : 0));
            });
        },

        showNotify: function ($message, $delay_time) {
            $('.fat-cmb-notified', 'body').remove();
            $('body').append('<div class="fat-cmb-notified">' + $message + '</div>');
            $delay_time = typeof $delay_time != 'undefined' && !isNaN($delay_time) ? $delay_time : 5000;
            setTimeout(function(){
                $('.fat-cmb-notified', 'body').addClass('show-up');
                setTimeout(function () {
                    $('.fat-cmb-notified', 'body').removeClass('show-up');
                }, $delay_time);
            })

        }
    };
    $(document).ready(function () {
        FatCmbCategoryImage.setFatCmbCategoryImageSortable();
        FatCmbCategoryImage.registerAddFatCmbCategoryImage();
        FatCmbCategoryImage.setFatCmbCategoryImageEdit();
        FatCmbCategoryImage.registerDeleteFatCmbCategoryImage();

        FatCmbCategoryImage.initJTreeCategory();
    });

});