<?php
/**
 * Created by PhpStorm.
 * User: PhuongTH
 * Date: 10/7/2017
 * Time: 9:44 AM
 */
namespace FAT_Libs;

class fat_cmb_category_images
{
    public $metabox_id;
    public $id;
    public $label;
    public $std = '';
    public $col_width = 'fat-cmb-col-12';
    public $description = '';
    public $depend_field = null;
    public $css_class = '';

    public function __construct()
    {
        $this->enqueue_script();
    }

    private function enqueue_script()
    {
        wp_enqueue_media();
        wp_enqueue_style('fat-jquery-confirm-'.__NAMESPACE__, namespace\FAT_CMB_ASSET_JS_URL . 'jquery-confirm/jquery-confirm.min.css', array(), '3.3.0');
        wp_enqueue_style('fat-cmb-jtree-'.__NAMESPACE__, namespace\FAT_CMB_ASSET_JS_URL . 'jtree/themes/default/style.css', array(), false);

        wp_enqueue_script('fat-jquery-confirm-'.__NAMESPACE__, namespace\FAT_CMB_ASSET_JS_URL . 'jquery-confirm/jquery-confirm.min.js', array(), '3.3.0', true);
        wp_enqueue_script('fat-cmb-jtree-'.__NAMESPACE__, namespace\FAT_CMB_ASSET_JS_URL . 'jtree/jstree.js', array(), '3.3.4', true);

        wp_register_script('fat-cmb-category-images-'.__NAMESPACE__, namespace\FAT_CMB_ASSET_JS_URL . 'category_images.js', array(), '3.0.5', true);
        wp_localize_script('fat-cmb-category-images-'.__NAMESPACE__, 'fat_data', array(
            'root' => home_url('/'),
            'upload_dir' => wp_upload_dir()
        ));
        wp_enqueue_script('fat-cmb-category-images-'.__NAMESPACE__);
    }

    public function render()
    {
        global $fat_cmb_post_meta;
        $post_meta = isset($fat_cmb_post_meta[$this->metabox_id][0]) ? unserialize($fat_cmb_post_meta[$this->metabox_id][0]) : '';

        $image_ids = isset($post_meta[$this->id]) ? $post_meta[$this->id] : '';
        $images = array();
        if ($image_ids != '') {
            $ids = explode(',', $image_ids);
            $url = '';
            global $wpdb;
            $sql = "SELECT ID, guid FROM {$wpdb->prefix}posts WHERE ID IN(".$image_ids.")";
            $attachments = $wpdb->get_results($sql);
            foreach($attachments as $att){
                $images[] = array(
                    'id' => $att->ID,
                    'url' => $att->guid
                );
            }
           /* foreach ($ids as $id) {
                $url = wp_get_attachment_thumb_url($id);
                $images[] = array(
                    'id' => $id,
                    'url' => $url
                );
            }*/
        }

        $data_depend_field = isset($this->depend_field['field']) ? sprintf(' data-depend-field="%s" ', $this->depend_field['field']) : '';
        $data_depend_field .= isset($this->depend_field['value']) ? sprintf(' data-depend-value="%s" ', $this->depend_field['value']) : '';
        $data_depend_field .= isset($this->depend_field['compare']) ? sprintf(' data-depend-compare="%s" ', $this->depend_field['compare']) : '';

        ?>
        <div
                class="<?php echo esc_attr($this->col_width) ?> <?php echo esc_attr($this->css_class) ?> fat-cmb-images-wrap category-image-wrap" <?php echo sprintf('%s', $data_depend_field); ?>>
            <label for="<?php echo esc_attr($this->id) ?>"><?php echo esc_attr($this->label) ?><span
                        class="fat-icon-help" data-tooltip-content="#tooltip_content_<?php echo esc_attr($this->id) ?>"><i
                            class="dashicons dashicons-editor-help"></i></span></label>

            <div class="fat-tooltip-templates">
                <div id="tooltip_content_<?php echo esc_attr($this->id) ?>">
                    To use gallery, please create category at column left and choose gallery for category at column right
                   <ul>
                       <li>1. To create category:
                            <ul>
                                <li> - Please choose 'Category Filter' and click right mouse button</li>
                                <li> - Choose 'Create' at context menu</li>
                                <li> - Input category title</li>
                            </ul>
                       </li>
                       <li>2. To add gallery:
                           <ul>
                               <li> - Please choose category what need add gallery at column left</li>
                               <li> - Choose 'Add Image' at column right</li>
                               <li> - Choose image from popup gallery. Use Ctrl + left mouse button for multi select</li>
                           </ul>
                       </li>
                       <li>3. To change title, description, link to detail, video embed:
                            <ul>
                                <li> - Hover on image what need change</li>
                                <li> - Click icon <i class="dashicons dashicons-edit"></i> to open form edit</li>
                                <li> - Input into title, description, link, video embed</li>
                                <li> - Click save to store data</li>
                            </ul>
                       </li>
                   </ul>
                    <span class="note" style="color: tomato">Note: You need click 'Publish' or 'Update' button at 'Publish' section to store any change into database</span>
                </div>
            </div>

            <div class="fat-add-image-wrap fat-cmb-field">
            <input type="hidden" name="<?php echo esc_attr($this->id) ?>" id="<?php echo esc_attr($this->id) ?>"
                       value="<?php echo esc_attr($image_ids); ?>">
                <div class="fat-category-list">
                    <div class="fat-jtree-category">
                    </div>
                </div>
                <div class="fat-list-image-wrap">
                    <div class="fat-list-image" data-input-id="<?php echo esc_attr($this->id) ?>">
                        <?php
                        if (isset($images)):
                            foreach ($images as $image) { ?>
                                <div class="fat-image-thumb" data-id="<?php echo esc_attr($image['id']); ?>">
                                    <img src="<?php echo esc_attr($image['url']); ?>"/>
                                    <div class="fat-overlay fat-transition-30">
                            <span>
                                <a class="fat-delete-image" data-id="<?php echo esc_attr($image['id']); ?>"
                                   href="javascript:"><i
                                            class="dashicons dashicons-no-alt"></i></a>
                            </span>
                                    </div>
                                </div>
                            <?php }
                        endif;
                        ?>
                    </div>
                    <a href="javascript:" class="fat-add-image"
                       data-input-id="<?php echo esc_attr($this->id) ?>"><?php esc_html_e('Add image', 'fat-cmb'); ?></a>
                </div>
            </div>
            <div class="hidden fat-form-template fat-cmb-category-edit">
                <div class="fat-cmb-category-edit-inner">
                    <div class="half-field">
                        <label><?php echo esc_html__('Title', 'fat-cmb'); ?></label>
                        <input type="text" class="fat-cmb-image-title">
                    </div>
                    <div class="half-field">
                        <label><?php echo esc_html__('Link to detail'); ?></label>
                        <input type="text" class="fat-cmb-image-link">
                    </div>
                    <div class="full-field">
                        <label><?php echo esc_html__('Description', 'fat-cmb'); ?></label>
                        <textarea class="fat-cmb-image-description"></textarea>
                    </div>
                    <div class="full-field">
                        <label><?php echo esc_html__('Video URL', 'fat-cmb'); ?></label>
                        <textarea class="fat-cmb-image-video-embed"></textarea>
                    </div>
                    <div class="full-field">
                        <input type="button" class="fat-cmb-image-save button button-primary button-large"
                               value="<?php echo esc_html__('Save', 'fat-cmb'); ?>">
                        <input type="button" class="fat-cmb-image-cancel button  button-large"
                               value="<?php echo esc_html__('Cancel', 'fat-cmb'); ?>">
                    </div>
                </div>
            </div>
            <div class="hidden fat-form-template fat-cmb-cat-info">
                <div class="fat-cmb-cat-info-inner">
                    <a class="fat-cmb-close-popup" href="javascript:"><i class="fa fa-close"></i></a>
                    <div class="full-field">
                        <label><?php echo esc_html__('ID', 'fat-cmb'); ?></label>
                        <span class="fat-cmb-cat-id"></span>
                    </div>
                    <div class="full-field">
                        <label><?php echo esc_html__('Category', 'fat-cmb'); ?></label>
                        <input type="text" class="fat-cmb-cat-title"  readonly disabled>
                    </div>
                    <div class="full-field">
                        <label><?php echo esc_html__('Caption', 'fat-cmb'); ?></label>
                        <input type="text" class="fat-cmb-cat-caption">
                    </div>
                    <div class="full-field">
                        <label><?php echo esc_html__('Description', 'fat-cmb'); ?></label>
                        <textarea class="fat-cmb-cat-description" rows="5"></textarea>
                    </div>
                    <div class="full-field link-to-detail">
                        <label><?php echo esc_html__('Link to detail', 'fat-cmb'); ?></label>
                        <input type="text" class="fat-cmb-cat-link">
                    </div>
                    <div class="full-field button-groups">
                        <input type="button" class="fat-cmb-cat-save button button-primary button-large"
                               value="<?php echo esc_html__('Save', 'fat-cmb'); ?>">
                        <input type="button" class="fat-cmb-cat-cancel button  button-large"
                               value="<?php echo esc_html__('Cancel', 'fat-cmb'); ?>">
                    </div>
                </div>
            </div>
            <?php if (isset($this->description) && $this->description != ''): ?>
                <span class="fat-cmb-description"><?php echo esc_html($this->description); ?> </span>
            <?php endif; ?>
        </div>
    <?php }
}