<?php
/**
 * Created by PhpStorm.
 * User: Roninwp
 * Date: 10/15/2016
 * Time: 10:03 PM
 */
namespace FAT_Libs;

class fat_cmb_image_select
{

    public $repeat_id;
    public $repeat_value;
    public $repeat_index;
    public $metabox_id;
    public $id;
    public $label;
    public $std = '';
    public $slide = false;
    public $column = 3;
    public $col_width = 'fat-cmb-col-12';
    public $options = array();
    public $description = '';
    public $depend_field = null;
    public $css_class = '';

    public function __construct()
    {
        $this->enqueue_script();
    }

    private function enqueue_script()
    {
        //if ($this->slide) {
            wp_enqueue_style('fat-cmb-owl-carousel-'.__NAMESPACE__, namespace\FAT_CMB_ASSET_JS_URL . 'owl-carousel/assets/owl.carousel.min.css', array(), false);
        wp_enqueue_script('fat-cmb-imageloaded-'.__NAMESPACE__, namespace\FAT_CMB_ASSET_JS_URL . 'imagesloaded.pkgd.min.js', array('jquery'), false);
            wp_enqueue_script('fat-cmb-owl-carousel-'.__NAMESPACE__, namespace\FAT_CMB_ASSET_JS_URL . 'owl-carousel/owl.carousel.min.js', array('jquery'), false);
        //}
        wp_enqueue_script('fat-cmb-image-select-'.__NAMESPACE__, namespace\FAT_CMB_ASSET_JS_URL . 'image-select.js', array(), '1.0.0', true);
    }

    public function render()
    {
        global $fat_cmb_post_meta;
        $post_meta = isset($fat_cmb_post_meta[$this->metabox_id][0]) ? unserialize($fat_cmb_post_meta[$this->metabox_id][0]) : '';
        if (isset($this->repeat_id)) {
            $image_select_value = isset($this->repeat_value) ? $this->repeat_value : $this->std;
        } else {
            $image_select_value = isset($post_meta[$this->id]) ? $post_meta[$this->id] : $this->std;
        }

        $data_depend_field = isset($this->depend_field['field']) ? sprintf(' data-depend-field="%s" ', $this->depend_field['field']) : '';
        $data_depend_field .= isset($this->depend_field['value']) ? sprintf(' data-depend-value="%s" ', $this->depend_field['value']) : '';
        $data_depend_field .= isset($this->depend_field['compare']) ? sprintf(' data-depend-compare="%s" ', $this->depend_field['compare']) : '';

        $field_id = isset($this->repeat_id) ? sprintf('%s_%s', $this->repeat_id, $this->id) : $this->id;
        $field_name = isset($this->repeat_id) ? sprintf('%s_%s[]', $this->repeat_id, $this->id) : $this->id;
        $owl_options = '';
        if ($this->slide) {
            $start_index = 0;
            if (isset($this->options) && is_array($this->options)) {
                for($i=0; $i< count($this->options); $i++){
                    if($this->options[$i]['value'] === $image_select_value){
                        $start_index = $i;
                        break;
                    }
                    $i++;
                }
            }
            $owl_options = array(
                "items" => $this->column,
                "margin" => 0,
                "dots" => true,
                "nav" => false,
                "autoHeight" => 'true',
                "autoplay" => false,
                "startPosition" => $start_index
            );
        }
        $owl_options = json_encode($owl_options);
        $item_class = 'fat-cmb-image-select-item';
        $item_class .= isset($this->column) ? (' fat-cmb-col-'. 12/$this->column) : ' fat-cm-col-4';
        ?>
        <div
                class="<?php echo esc_attr($this->col_width) ?> <?php echo esc_attr($this->css_class) ?> fat-cmb-image-select-wrap" <?php echo sprintf('%s', $data_depend_field); ?> >
            <label for="<?php echo esc_attr($this->id) ?>"><?php echo esc_attr($this->label) ?></label>
            <div class="fat-cmb-field <?php echo isset($this->slide) && $this->slide ? 'owl-carousel' : ''; ?>"
                 data-owl-options="<?php echo esc_attr($owl_options); ?>">
                <?php
                if (isset($this->options) && is_array($this->options)) {
                    foreach ($this->options as $option) { ?>
                        <div class="<?php echo esc_attr($item_class); ?> <?php echo isset($option['value']) && $option['value'] === $image_select_value ? 'active' : ''; ?>"
                             data-value="<?php echo esc_attr($option['value']); ?>">
                            <div class="image-item-inner">
                                <img src="<?php echo esc_url($option['image']); ?>"
                                     title="<?php echo esc_attr($option['title']); ?>">
                                <a class="select-image"><i class="fa fa-check-square-o"></i></a>
                                <span class="layout-title"><?php echo esc_html($option['title']); ?></span>
                            </div>
                        </div>
                    <?php }
                } ?>

            </div>
            <input type="hidden" name="<?php echo esc_attr($field_name) ?>"
                   value="<?php echo esc_attr($image_select_value); ?>"
                   id="<?php echo esc_attr($field_id) ?>"
                   data-field-id="<?php echo esc_attr($this->id) ?>"
                   data-std="<?php echo esc_attr($this->std); ?>"
            />

            <?php if (isset($this->description) && $this->description != ''): ?>
                <span class="fat-cmb-description"><?php echo esc_html($this->description); ?> </span>
            <?php endif; ?>
        </div>
    <?php }
}