<?php
/**
 * Created by PhpStorm.
 * User: PhuongTH
 * Date: 10/14/2017
 * Time: 4:01 PM
 */

$gallery_images = json_decode($gallery_images, true);
$images = array();
foreach ($gallery_images as $gallery) {
    if (isset($gallery['imgs'])) {
        foreach ($gallery['imgs'] as $img) {
            $attachments[] = $img['id'];
            $images[$img['id']] = array(
                'cat_id' => $gallery['id'],
                'cat_name' => $gallery['text'],
                'title' => $img['title'],
                'description' => $img['description'],
                'link' => $img['link'],
                'video_embed' => $img['video_embed'],
                'is_exists' => ''
            );

            $images[$img['id']]['url_origin'] = wp_get_attachment_image_url($img['id'], $popup_image_size);
            $resize = fat_maika_matthewruddy_image_resize_id($img['id'], $image_width, $image_height);
            if ($resize != null && is_array($resize)) {
                $images[$img['id']]['thumb'] = $resize['url'];
                $images[$img['id']]['width'] = $image_width;
                $images[$img['id']]['height'] = $image_height;
            } else {
                $images[$img['id']]['thumb'] = $images[$img['id']]['url_origin'];
            }
        }
    }
}

$item_class = 'fat-gallery-item fat-col-md-' . (12 / $column);
$item_class .= ' ' . $skin;
$container_class = 'fat-maika-container fat-maika-shortcode-' . $gallery_id;
$container_class .= isset($popup_gallery) ? ' ' . $popup_gallery : '';
$container_class .= isset($disable_download) && $disable_download === 'on' ? ' disable-download' : '';
$container_class .= isset($disable_share) && $disable_share === 'on' ? ' disable-share' : '';
$container_class .= isset($show_thumbnail) && $show_thumbnail === 'on' ? ' show-thumbnail' : '';

$categories = FAT_Maika_Utils::get_category($gallery_images);
$imgs = array();
$album_animation = isset($gallery_config['album_animation']) ? $gallery_config['album_animation'] : 'random';
$animation_class = $album_animation;
$rand = 0;
$random_animation = array('fat-album-anim-1', 'fat-album-anim-2', 'fat-album-anim-3', 'fat-album-anim-4', 'fat-album-anim-5', 'fat-album-anim-6', 'fat-album-anim-7', 'fat-album-anim-8', 'fat-album-anim-9');
?>
<div class="<?php echo esc_attr($container_class); ?>" data-maika-col="<?php echo esc_attr(12 / $column); ?>"
     data-animation="<?php echo esc_attr($animation); ?>"
     data-animation-duration="<?php echo esc_attr($animation_duration); ?>">
    <div class="fat-maika-listing album-preview <?php echo esc_attr($gutter); ?>">
        <div class="albums-inner">
            <?php if (isset($categories['sub_cat'])):
                $index = 0;
                foreach ($categories['sub_cat'] as $sub_cat) {
                    $imgs = FAT_Maika_Utils::get_imgs($sub_cat['id'], $gallery_images);
                    if ($album_animation == 'random') {
                        $rand = mt_rand(0, 8);
                        $animation_class = $random_animation[$rand];
                    }
                    $index = 0;
                    ?>
                    <div class="fat-gallery-item fat-col-md-<?php echo esc_attr(12 / $column); ?> fat-col-sm-6 fat-col-xs-12">
                        <div class="fat-albums-tab">
                            <div class="fat-albums-tab-container hover-<?php echo esc_attr($animation_class); ?>">
                                <div class="fat-albums-tab-thumb <?php echo esc_attr($animation_class); ?>">
                                    <?php foreach ($imgs as $img) {
                                        if($index==0 || $album_animation!=='no-animation'):?>
                                        <img src="<?php echo esc_url($images[$img['id']]['thumb']); ?>"
                                             data-title="<?php echo esc_attr($images[$img['id']]['title']); ?>"
                                             data-desc="<?php echo esc_attr($images[$img['id']]['description']); ?>"
                                             data-img="<?php echo esc_attr($images[$img['id']]['url_origin']); ?>"
                                             data-video="<?php echo esc_attr($images[$img['id']]['video_embed']); ?>"
                                             data-thumb="<?php echo esc_attr($images[$img['id']]['thumb']); ?>"
                                             data-width="<?php echo isset($images[$img['id']]['orig_width']) ? $images[$img['id']]['orig_width'] : '900'; ?>"
                                             data-height="<?php echo isset($images[$img['id']]['orig_height']) ? $images[$img['id']]['orig_height'] : '600'; ?>"
                                        />
                                        <?php else: ?>
                                            <span class="fat-album-hd-item"
                                                 data-title="<?php echo esc_attr($images[$img['id']]['title']); ?>"
                                                 data-desc="<?php echo esc_attr($images[$img['id']]['description']); ?>"
                                                 data-img="<?php echo esc_attr($images[$img['id']]['url_origin']); ?>"
                                                 data-video="<?php echo esc_attr($images[$img['id']]['video_embed']); ?>"
                                                 data-thumb="<?php echo esc_attr($images[$img['id']]['thumb']); ?>"
                                                 data-width="<?php echo isset($images[$img['id']]['orig_width']) ? $images[$img['id']]['orig_width'] : '900'; ?>"
                                                 data-height="<?php echo isset($images[$img['id']]['orig_height']) ? $images[$img['id']]['orig_height'] : '600'; ?>"
                                            ></span>
                                        <?php endif;?>
                                    <?php
                                        $index++;
                                    } ?>
                                </div>
                                <div class="fat-album-view-gallery-icon">
                                    <a class="fat-album-view-gallery"><i class="icon-magnifier icons"></i></a>
                                </div>
                            </div>
                            <div class="fat-albums-tab-text"><?php echo esc_html($sub_cat['text']); ?>
                                <div class="fat-image-count">
                                    (<?php echo esc_attr(count($imgs)) . esc_html__(' pictures', 'maika'); ?>)
                                </div>
                            </div>
                        </div>
                    </div>
                    <?php
                }
            endif;
            ?>
        </div>
        <div class="clear"></div>
    </div>
</div>