<?php
/**
 * Created by PhpStorm.
 * User: PhuongTH
 * Date: 10/14/2017
 * Time: 4:01 PM
 */

$gallery_images = json_decode($gallery_images, true);
$images = $img_cats = $resize = array();
$total_found = 0;
$img_index = 0;
$attachments = array();
$default_category = '';
foreach ($gallery_images as $gallery) {
    if(isset($gallery['imgs'])){
        foreach ($gallery['imgs'] as $img) {
            $total_found++;
            $img_index = $img['id'].'_'.$gallery['id'];
            $default_category = isset($gallery['is_default']) && $gallery['is_default']=='1' ? $gallery['id'] : $default_category;
            $images[$img_index] = array(
                'id' => $img['id'],
                'cat_id' => $gallery['id'],
                'cat_name' => $gallery['text'],
                'title' => $img['title'],
                'description' => $img['description'],
                'link' => $img['link'],
                'video_embed' => $img['video_embed'],
                'is_exists' => ''
            );

            $images[$img_index]['url_origin'] = wp_get_attachment_image_url($img['id'],$popup_image_size);
            $resize = fat_maika_matthewruddy_image_resize_id($img['id'], $image_width, $image_height);
            if ($resize != null && is_array($resize)) {
                $images[$img_index]['thumb'] = $resize['url'];
                $images[$img_index]['width'] = $image_width;
                $images[$img_index]['height'] = $image_height;
            } else {
                $images[$img_index]['thumb'] = $images[$img_index]['url_origin'];
            }
            if(in_array($img['id'],$attachments)){
                $images[$img_index]['is_exists'] = ' duplicate-image';
            }
            $attachments[] = $img['id'];
        }
    }
}

$item_class = 'fat-gallery-item fat-col-sm-6 fat-col-xs-12 fat-col-md-' . (12 / $column);
$item_class .= ' ' . $skin;
$item_class .= ' ' . $image_scale_when_hover;
$container_class = 'fat-maika-container carousel fat-maika-shortcode-' . $gallery_id;
$container_class .= isset($popup_gallery) ? ' ' . $popup_gallery : '';
$container_class .= isset($disable_download) && $disable_download === 'on' ? ' disable-download' : '';
$container_class .= isset($disable_share) && $disable_share === 'on' ? ' disable-share' : '';
$container_class .= isset($show_thumbnail) && $show_thumbnail==='on' ? ' show-thumbnail' : '';
$container_class .= $has_animation;
$container_class .= isset($enable_filter) && $enable_filter ? ' root-filter' : '';
$container_class .= $default_category ? ' has-category-default' : '';

if($order=='RANDOM'){
    shuffle($images);
}
if($order=='DATE'){
    usort($images, function($a, $b) {
        if($a['id'] == $b['id']){
            return 0;
        }
        return $a['id'] < $b['id'] ? -1 : 1;
    });
}
if($order=='DATE_DESC'){
    usort($images, function($a, $b) {
        if($a['id'] == $b['id']){
            return 0;
        }
        return $a['id'] < $b['id'] ? 1 : -1;
    });
}

$owl_options = array(
    "responsive" => array(
        980 => array(
            "items" => $column
        ),
        768 => array(
            "items" => $column < 3 ? $column : 3
        ),
        480 => array(
            "items" => $column < 2 ? $column : 2
        ),
        320 => array(
            "items" => 1
        )
    ),
    "margin" => isset($gallery_config['margin']) && $gallery_config['margin'] ?  intval($gallery_config['margin']) : 0,
    "dots" => isset($gallery_config['carousel_nav']) && $gallery_config['carousel_nav'] === 'dot',
    "nav" => isset($gallery_config['carousel_nav']) && $gallery_config['carousel_nav'] === 'nav',
    "autoHeight" => 'true',
    "autoplay" => isset($gallery_config['carousel_autoplay']) && $gallery_config['carousel_autoplay'] == '1',
    "loop" => isset($gallery_config['carousel_loop']) && $gallery_config['carousel_loop'] == '1',
    "autoplayTimeout" => isset($gallery_config['carousel_timeout']) && $gallery_config['carousel_timeout'] ? $gallery_config['carousel_timeout'] : 4000,
    "rtl" => isset($gallery_config['carousel_rtl']) && $gallery_config['carousel_rtl'] == 'true'
);
$owl_options = json_encode($owl_options);

?>
<div class="<?php echo esc_attr($container_class); ?>" data-maika-col="<?php echo esc_attr(12 / $column); ?>"
     data-animation="<?php echo esc_attr($animation); ?>" data-animation-duration="<?php echo esc_attr($animation_duration); ?>">
   <!-- --><?php /*if ($enable_filter) {
        $filte_template = FAT_MAIKA_DIR_PATH . 'templates/filters/' . $filter_layout . '.php';
        if (file_exists($filte_template)) {
            include $filte_template;
        }
    } */?>
    <div class="fat-maika-listing owl-carousel" data-owl-options="<?php echo esc_attr($owl_options); ?>">
        <?php
        $skin_template = FAT_MAIKA_DIR_PATH . '/templates/skins/' . $skin . '.php';
        if (file_exists($skin_template)) {
            $lazy_load = 0;
            foreach ($images as $image) {
                include $skin_template;
            }
        }
        ?>
    </div>
    <?php if ($paging_type !== 'show-all' && $lazy_load) {
        $paging_template = FAT_MAIKA_DIR_PATH . '/templates/pagings/' . $paging_type . '.php';
        if (file_exists($paging_template)) {
            include $paging_template;
        }
    } ?>
</div>