<?php
/**
 * Created by PhpStorm.
 * User: PhuongTH
 * Date: 10/14/2017
 * Time: 4:01 PM
 */

$gallery_images = json_decode($gallery_images, true);
$images = array();
foreach ($gallery_images as $gallery) {
    if (isset($gallery['imgs'])) {
        foreach ($gallery['imgs'] as $img) {
            $attachments[] = $img['id'];
            $images[$img['id']] = array(
                'cat_id' => $gallery['id'],
                'cat_name' => $gallery['text'],
                'title' => $img['title'],
                'description' => $img['description'],
                'link' => $img['link'],
                'video_embed' => $img['video_embed'],
                'is_exists' => ''
            );

            $images[$img['id']]['url_origin'] = wp_get_attachment_image_url($img['id'],$popup_image_size);
            $resize = fat_maika_matthewruddy_image_resize_id($img['id'], $image_width, $image_height);
            if ($resize != null && is_array($resize)) {
                $images[$img['id']]['thumb'] = $resize['url'];
                $images[$img['id']]['width'] = $image_width;
                $images[$img['id']]['height'] = $image_height;
            } else {
                $images[$img['id']]['thumb'] = $images[$img['id']]['url_origin'];
            }
        }
    }
}
$item_class = 'fat-gallery-item fat-col-md-' . (12 / $column);
$item_class .= ' ' . $skin;
$container_class = 'fat-maika-container horizontal-slide fat-maika-shortcode-' . $gallery_id;
$container_class .= isset($popup_gallery) ? ' ' . $popup_gallery : ' fat-lightbox-gallery';
$container_class .= isset($disable_download) && $disable_download==='on' ? ' disable-download' : '';
$container_class .= isset($disable_share) && $disable_share === 'on' ? ' disable-share' : '';
$container_class .= isset($show_thumbnail) && $show_thumbnail==='on' ? ' show-thumbnail' : '';

$categories = FAT_Maika_Utils::get_category($gallery_images);
$imgs = array();
$gallery_json = array();
$cat_thumb = '';
?>
<div class="<?php echo esc_attr($container_class); ?>" data-maika-col="<?php echo esc_attr(12 / $column); ?>"
     data-animation="<?php echo esc_attr($animation); ?>"
     data-animation-duration="<?php echo esc_attr($animation_duration); ?>">
    <div class="fat-maika-listing <?php echo esc_attr($gutter); ?>">
        <ul class="fat-maika-slide-items">
            <?php if (isset($categories['sub_cat'])):
                foreach ($categories['sub_cat'] as $sub_cat) {
                    $imgs = FAT_Maika_Utils::get_imgs($sub_cat['id'], $gallery_images);
                    $gallery_json = array();
                    $cat_thumb = '';
                    foreach ($imgs as $img) {
                        if($cat_thumb == ''){
                            $cat_thumb = $images[$img['id']]['thumb'];
                        }
                        $gallery_json[] = array(
                            'url' => $images[$img['id']]['url_origin'],
                            'thumb' => $images[$img['id']]['thumb'],
                            'title' => $images[$img['id']]['title'],
                            'description' => $images[$img['id']]['description'],
                            'link' => $images[$img['id']]['link'],
                            'video_embed' => $images[$img['id']]['video_embed']
                        );
                    }
                    $gallery_json = json_encode($gallery_json);
                    ?>
                    <li class="fat-gallery-item fat-col-md-<?php echo esc_attr(12 / $column); ?> fat-col-sm-6 fat-col-xs-12">
                        <div class="fat-item-thumb-wrap" data-gallery="<?php echo esc_attr($gallery_json); ?>">
                            <div class="fat-item-thumb"><img
                                        src="<?php echo esc_url($cat_thumb); ?>"/></div>
                            <div class="fat-view-gallery-icon">
                                <a class="fat-view-gallery" href="javascript:"><i class="icon-magnifier icons"></i></a>
                            </div>
                        </div>
                        <div class="fat-cat-title"><?php echo esc_html($sub_cat['text']); ?> </div>
                    </li>
                <?php }
            endif;
            ?>
        </ul>
    </div>
</div>