<?php
/**
 * Created by PhpStorm.
 * User: PhuongTH
 * Date: 10/14/2017
 * Time: 4:01 PM
 */

$row_height = isset($gallery_config['row_height']) ? $gallery_config['row_height'] : 100;
$margin = isset($gallery_config['margin']) ? $gallery_config['margin'] : 0;
$justify_last_row = isset($gallery_config['justify_last_row'][0]) && $gallery_config['justify_last_row'][0]=='1' ? 1 : 0;
$item_per_page = isset($gallery_config['justified_item_per_page']) && $gallery_config['justified_item_per_page']!='' ? $gallery_config['justified_item_per_page'] : 0;
$justify_random = isset($gallery_config['justify_random'][0]) && $gallery_config['justify_random'][0]=='1' ? 1 : 0;

$gallery_images = json_decode($gallery_images, true);
$images = array();
foreach ($gallery_images as $gallery) {
    if (isset($gallery['imgs'])) {
        foreach ($gallery['imgs'] as $img) {
            $attachments[] = $img['id'];
            $images[$img['id']] = array(
                'cat_id' => $gallery['id'],
                'cat_name' => $gallery['text'],
                'title' => $img['title'],
                'description' => $img['description'],
                'link' => $img['link'],
                'video_embed' => $img['video_embed'],
                'is_exists' => ''
            );

            $images[$img['id']]['url_origin'] = wp_get_attachment_image_url($img['id'],$popup_image_size);
            if(substr(strrchr($images[$img['id']]['url_origin'],'.'),1) === 'gif'){
                $images[$img['id']]['thumb'] = $images[$img['id']]['url_origin'];
            }else{
                fat_resize_constrain($img['id'], $image_width, $image_height);
                $resize = fat_maika_matthewruddy_image_resize_id($img['id'], $image_width, $image_height);
                if ($resize != null && is_array($resize)) {
                    $images[$img['id']]['thumb'] = $resize['url'];
                    $images[$img['id']]['width'] = $image_width;
                    $images[$img['id']]['height'] = $image_height;
                } else {
                    $images[$img['id']]['thumb'] = $images[$img['id']]['url_origin'];
                }
            }

        }
    }
}

$item_class = 'fat-gallery-item';
$item_class .= ' ' . $skin;
$item_class .= ' ' . $image_scale_when_hover;
$container_class = 'fat-maika-container fat-maika-shortcode-' . $gallery_id;
$container_class .= isset($popup_gallery) ? ' ' . $popup_gallery : '';
$container_class .= isset($disable_download) && $disable_download==='on' ? ' disable-download' : '';
$container_class .= isset($disable_share) && $disable_share === 'on' ? ' disable-share' : '';
$container_class .= isset($show_thumbnail) && $show_thumbnail==='on' ? ' show-thumbnail' : '';

if($justify_random){
    shuffle($images);
}
$has_infinite = count($images) > $item_per_page;
?>
<div class="<?php echo esc_attr($container_class); ?>">
    <div class="fat-maika-listing fat-lightbox-gallery justified <?php echo($has_infinite ? 'has-infinite' : ''); ?>
    <?php echo isset($show_thumbnail) && $show_thumbnail==='on' ? ' show-thumbnail' : ''; ?>
    <?php echo isset($disable_download) && $disable_download==='on' ? ' disable-download' : ''; ?>"
         data-row-height="<?php echo esc_attr($row_height); ?>" data-margin="<?php echo esc_attr($margin); ?>">
        <?php
        $index = 1;
        foreach ($images as $image) {
            if ($index <= $item_per_page || $item_per_page==0) {
                ?>
                <div class="<?php echo esc_attr($item_class); ?>"
                     data-thumb="<?php echo esc_attr($image['thumb']); ?>">
                    <img src="<?php echo esc_url($image['thumb']); ?>"
                         width="<?php echo(isset($image['width']) ? $image['width'] : 375); ?>"
                         height="<?php echo(isset($image['height']) ? $image['height'] : 275); ?>"/>
                    <div class="fat-album-view-gallery-icon"
                         data-title="<?php echo esc_attr($image['title']); ?>"
                         data-desc="<?php echo esc_attr($image['description']); ?>"
                         data-img="<?php echo esc_attr($image['url_origin']); ?>"
                         data-video="<?php echo esc_attr($image['video_embed']); ?>"
                         data-thumb="<?php echo esc_attr($image['thumb']); ?>"
                         data-width="900"
                         data-height="600">
                        <a class="fat-album-view-gallery fat-maika-icon"><i class="icon-magnifier icons"></i></a>
                    </div>
                </div>
            <?php }
            $index++;
        }
        ?>
    </div>
    <?php if ($has_infinite): ?>
        <div class="justified-infinite" data-item-per-page="<?php echo esc_attr($item_per_page);?>"></div>
        <div style="display: none" class="justified-lazy-load">
            <?php
            $index = 1;
            foreach ($images as $image) {
                if ($index > $item_per_page && $item_per_page > 0) {
                    ?>
                    <div class="<?php echo esc_attr($item_class); ?>"
                         data-thumb="<?php echo esc_attr($image['thumb']); ?>">
                        <div class="fat-album-view-gallery-icon"
                             data-title="<?php echo esc_attr($image['title']); ?>"
                             data-desc="<?php echo esc_attr($image['description']); ?>"
                             data-img="<?php echo esc_attr($image['url_origin']); ?>"
                             data-video="<?php echo esc_attr($image['video_embed']); ?>"
                             data-thumb="<?php echo esc_attr($image['thumb']); ?>"
                             data-width="900"
                             data-height="600">
                            <a class="fat-album-view-gallery fat-maika-icon"><i
                                        class="icon-magnifier icons"></i></a>
                        </div>
                    </div>
                <?php }
                $index++;
            }
            ?>
        </div>
    <?php endif; ?>
</div>