<?php
/**
 * Created by PhpStorm.
 * User: PhuongTH
 * Date: 10/14/2017
 * Time: 4:01 PM
 */

$gallery_images = json_decode($gallery_images, true);
$images = $img_cats = $resize = array();
$total_found = 0;
$attachments = array();
$default_category = '';
foreach ($gallery_images as $gallery) {
    if (isset($gallery['imgs'])) {
        foreach ($gallery['imgs'] as $img) {
            $total_found++;
            $img_index = $img['id'].'_'.$gallery['id'];
            $default_category = isset($gallery['is_default']) && $gallery['is_default']=='1' ? $gallery['id'] : $default_category;
            if($default_category=='' && $disable_all_filter=='on'){
                $default_category = $gallery['id'];
                $gallery['is_default']='1';
            }

            $images[$img_index] = array(
                'id' => $img['id'],
                'cat_id' => $gallery['id'],
                'cat_name' => $gallery['text'],
                'title' => $img['title'],
                'description' => $img['description'],
                'link' => $img['link'],
                'video_embed' => $img['video_embed'],
                'is_exists' => ''
            );

            $images[$img_index]['url_origin'] = wp_get_attachment_image_url($img['id'],$popup_image_size);
            if(substr(strrchr($images[$img_index]['url_origin'],'.'),1) === 'gif'){
                $images[$img_index]['thumb'] = $images[$img_index]['url_origin'];
            }else{
                fat_resize_constrain($img['id'], $image_width, $image_height);
                $resize = fat_maika_matthewruddy_image_resize_id($img['id'], $image_width, $image_height);
                if ($resize != null && is_array($resize)) {
                    $images[$img_index]['thumb'] = $resize['url'];
                    $images[$img_index]['width'] = $image_width;
                    $images[$img_index]['height'] = $image_height;
                } else {
                    $images[$img_index]['thumb'] = $images[$img['id']]['url_origin'];
                }
            }
            if(in_array($img['id'],$attachments)){
                $images[$img_index]['is_exists'] = ' duplicate-image';
            }
            $attachments[] = $img['id'];

            // process image belong multiple category
            /*if(!isset($img_cats[$img['id']])){
                $img_cats[$img['id']] = array($gallery['id']);
            }else{
                $img_cats[$img['id']][] = $gallery['id'];
            }*/
        }
    }
}

$item_class = 'fat-gallery-item fat-col-sm-6 fat-col-xs-12 fat-col-md-' . (12 / $column);
$item_class .= ' ' . $skin;
$item_class .= ' ' . $image_scale_when_hover;
$container_class = 'fat-maika-container isotope fat-maika-shortcode-' . $gallery_id;
$container_class .= isset($popup_gallery) ? ' ' . $popup_gallery : '';
$container_class .= isset($disable_download) && $disable_download==='on' ? ' disable-download' : '';
$container_class .= isset($disable_share) && $disable_share === 'on' ? ' disable-share' : '';
$container_class .= isset($show_thumbnail) && $show_thumbnail==='on' ? ' show-thumbnail' : '';
$container_class .= $has_animation;
$container_class .= isset($enable_filter) && $enable_filter ? ' root-filter' : '';
$container_class .= $default_category ? ' has-category-default' : '';

if ($order == 'RANDOM') {
    shuffle($images);
}
if($order=='DATE'){
    usort($images, function($a, $b) {
        if($a['id'] == $b['id']){
            return 0;
        }
        return $a['id'] < $b['id'] ? -1 : 1;
    });
}
if($order=='DATE_DESC'){
    usort($images, function($a, $b) {
        if($a['id'] == $b['id']){
            return 0;
        }
        return $a['id'] < $b['id'] ? 1 : -1;
    });
}

?>
<div class="<?php echo esc_attr($container_class); ?>" data-maika-col="<?php echo esc_attr(12 / $column); ?>" data-item-per-page="<?php echo esc_attr($item_per_page);?>"
     data-animation="<?php echo esc_attr($animation); ?>"
     data-animation-duration="<?php echo esc_attr($animation_duration); ?>">
    <?php if ($enable_filter) {
        $filte_template = FAT_MAIKA_DIR_PATH . 'templates/filters/' . $filter_layout . '.php';
        if (file_exists($filte_template)) {
            include $filte_template;
        }
    } ?>
    <div class="fat-maika-listing masonry <?php echo esc_attr($gutter); ?>">
        <?php
        $skin_template = FAT_MAIKA_DIR_PATH . '/templates/skins/' . $skin . '.php';
        if (file_exists($skin_template)) {
            $index = 1;
            $lazy_load = 0;
            $total_item = $total_item !== '' && $total_item < $total_found ? $total_item : $total_found;
            foreach ($images as $image) {
                if ($total_item < $index) {
                    break;
                }
                if ($item_per_page !== '' && $total_item > $item_per_page && $paging_type !== 'show-all') {
                    $lazy_load = $item_per_page >= $index ? 0 : 1;
                }
               /* if($default_category!==$image['cat_id'] && $default_category){
                    $lazy_load = 1;
                }*/
                include $skin_template;
                $index++;
            }
        }
        ?>
    </div>
    <?php if ($paging_type !== 'show-all' && $lazy_load) {
        $paging_template = FAT_MAIKA_DIR_PATH . '/templates/pagings/' . $paging_type . '.php';
        if (file_exists($paging_template)) {
            include $paging_template;
        }
    } ?>
</div>