<?php
/**
 * Created by PhpStorm.
 * User: PhuongTH
 * Date: 10/14/2017
 * Time: 4:01 PM
 */

$gallery_images = json_decode($gallery_images, true);
$images = array();
foreach ($gallery_images as $gallery) {
    if (isset($gallery['imgs'])) {
        foreach ($gallery['imgs'] as $img) {
            $images[$img['id']] = array(
                'cat_id' => $gallery['id'],
                'cat_name' => $gallery['text'],
                'title' => $img['title'],
                'description' => $img['description'],
                'link' => $img['link'],
                'video_embed' => $img['video_embed'],
                'is_exists' => ''
            );

            $images[$img['id']]['url_origin'] = wp_get_attachment_image_url($img['id'],$popup_image_size);
            $resize = fat_maika_matthewruddy_image_resize_id($img['id'], 300, 300);
            if ($resize != null && is_array($resize)) {
                $images[$img['id']]['thumb'] = $resize['url'];
                $images[$img['id']]['width'] = 300;
                $images[$img['id']]['height'] = 300;
            } else {
                $images[$img['id']]['thumb'] = $images[$img['id']]['url_origin'];
            }
        }
    }
}

$item_class = 'fat-gallery-item';
$item_class .= ' ' . $skin;
$container_class = 'fat-maika-container timeline fat-maika-shortcode-' . $gallery_id;
$container_class .= isset($popup_gallery) ? ' ' . $popup_gallery : '';
$container_class .= isset($disable_download) && $disable_download==='on' ? ' disable-download' : '';
$container_class .= isset($disable_share) && $disable_share === 'on' ? ' disable-share' : '';
$container_class .= isset($show_thumbnail) && $show_thumbnail==='on' ? ' show-thumbnail' : '';

$categories = FAT_Maika_Utils::get_category($gallery_images);
$imgs = array();
$gallery_json = array();
$cat_thumb = '';
?>
<div class="<?php echo esc_attr($container_class); ?>">
    <div class="fat-maika-listing">
        <section id="cd-timeline" class="cd-container">
            <?php if (isset($categories['sub_cat'])):
                foreach ($categories['sub_cat'] as $sub_cat) {
                    $imgs = FAT_Maika_Utils::get_imgs($sub_cat['id'], $gallery_images);
                    $gallery_json = array();
                    $cat_thumb = '';
                    foreach ($imgs as $img) {
                        if ($cat_thumb == '') {
                            $cat_thumb = $images[$img['id']]['thumb'];
                        }
                        $gallery_json[] = array(
                            'url' => $images[$img['id']]['url_origin'],
                            'thumb' => $images[$img['id']]['thumb'],
                            'title' => $images[$img['id']]['title'],
                            'description' => $images[$img['id']]['description'],
                            'link' => $images[$img['id']]['link'],
                            'video_embed' => $images[$img['id']]['video_embed']
                        );
                    }
                    $gallery_json = json_encode($gallery_json);
                    ?>
                    <div class="cd-timeline-block">
                        <div class="cd-timeline-img cd-picture"
                             title="<?php echo esc_html__('View gallery', 'maika'); ?>"
                             style="background-image: url(<?php echo esc_url($cat_thumb); ?>);"
                             data-gallery="<?php echo esc_attr($gallery_json); ?>">
                            <div class="fat-view-gallery-icon">
                                <a class="fat-view-gallery" href="javascript:"><i class="icon-magnifier icons"></i></a>
                            </div>
                        </div><div class="cd-timeline-content">
                            <?php
                            if (isset($sub_cat['caption']) && $sub_cat['caption'] != ''): ?>
                                <?php if (isset($sub_cat['link']) && $sub_cat['link'] != ''): ?>
                                    <a href="<?php echo esc_attr($sub_cat['link']); ?>">
                                        <h2><?php echo esc_html($sub_cat['caption']); ?></h2></a>
                                <?php else: ?>
                                    <h2><?php echo esc_html($sub_cat['caption']); ?></h2>
                                <?php endif; ?>
                            <?php endif; ?>
                            <p><?php echo esc_html($sub_cat['description']); ?></p>
                            <?php if (isset($sub_cat['link']) && $sub_cat['link'] != ''): ?>
                                <a href="<?php echo esc_attr($sub_cat['link']); ?>"
                                   class="cd-read-more"><?php echo esc_html__('Read more', 'maika'); ?></a>
                            <?php endif; ?>
                            <span class="cd-date"><?php echo esc_html($sub_cat['text']); ?></span>
                        </div> <!-- cd-timeline-content -->
                    </div> <!-- cd-timeline-block -->
                <?php }
            endif;
            ?>
        </section>
    </div>
</div>