<?php
/**
 * Created by PhpStorm.
 * User: PhuongTH
 * Date: 10/16/2017
 * Time: 1:25 PM
 */
if (!class_exists('FAT_Maika_Utils')) {
    class FAT_Maika_Utils
    {
        function __construct()
        {

        }

        static function get_category($galleries)
        {
            $categories = $root = $sub_category = $scan = array();
            $key = '';
            $temp_key = '';
            foreach ($galleries as $gallery) {
                $gallery['imgs'] = array();
                if ($gallery['parent'] === '#') {
                    $root = $gallery;
                } else {
                    if (!in_array($gallery['id'], $scan)) {
                        $scan[] = $gallery['id'];
                        $sub_category = FAT_Maika_Utils::get_sub_category($gallery['id'], $galleries, $scan);
                        if (count($sub_category) > 0) {
                            $gallery['sub_cat'] = $sub_category;
                        }

                        if (isset($gallery['order'])) {
                            $key = str_replace('j', '', $gallery['parent']);
                            $key = str_replace('_', '', $key);
                            $temp_key = $key . $gallery['order'];
                            $key .= array_key_exists($temp_key, $categories) ? mt_rand(10, 50) : $gallery['order'];
                            $categories[$key] = $gallery;
                        }
                    }
                }
            }
            ksort($categories);
            $root['sub_cat'] = $categories;
            return $root;
        }

        static function get_sub_category($cat_id, $galleries, &$scan)
        {
            $sub_category = array();
            $key = '';
            foreach ($galleries as $gallery) {
                if ($gallery['parent'] == $cat_id && !in_array($gallery['id'], $scan)) {
                    $scan[] = $gallery['id'];
                    $key = str_replace('j', '', $gallery['parent']);
                    $key = str_replace('_', '', $key);
                    $key .= $gallery['order'];
                    $gallery['sub_cat'] = FAT_Maika_Utils::get_sub_category($gallery['id'], $galleries, $scan);
                    $sub_category[$key] = $gallery;
                }
            }
            ksort($sub_category, SORT_NUMERIC);
            return $sub_category;
        }

        static function render_category($categories, $multi_level, $cat_count = array(), $is_sub = false)
        {
            $output = $item_class = $filter_count = $label = $active = '';

            foreach ($categories as $cat) {
                $filter_count = isset($cat_count[$cat['id']]) ? ('<span class="filter-count">' . $cat_count[$cat['id']] . '</span>') : '';
                $active = isset($cat['is_default']) && $cat['is_default'] == '1' ? 'active' : '';
                if (isset($multi_level) && $multi_level) {
                    $item_class = isset($cat['sub_cat']) && count($cat['sub_cat']) > 0 ? 'cat-item has-sub-cat' : 'cat-item';
                    if ($is_sub) {
                        $label = isset($cat_count[$cat['id']]) ? $cat['text'] . ' (' . $cat_count[$cat['id']] . ')' : $cat['text'];
                        $output .= sprintf('<li class="%s"><a href="javascript:void(0)" class="%s" data-category="%s" data-parent="%s">%s</a>', $item_class, $active, $cat['id'], $cat['parent'], $label);
                    } else {
                        $output .= sprintf('<li class="%s">%s<a href="javascript:void(0)" class="%s" data-category="%s" data-parent="%s">%s</a>', $item_class, $filter_count, $active, $cat['id'], $cat['parent'], $cat['text']);
                    }

                } else {
                    $output .= sprintf('<li>%s<a href="javascript:void(0)" class="%s" data-category="%s" data-parent="%s">%s</a></li>', $filter_count, $active, $cat['id'], $cat['parent'], $cat['text']);
                }

                if (isset($cat['sub_cat']) && count($cat['sub_cat']) > 0) {
                    $output .= isset($multi_level) && $multi_level ? '<ul class="sub-cat">' : '';
                    $output .= FAT_Maika_Utils::render_category($cat['sub_cat'], $multi_level, $cat_count, true);
                    $output .= isset($multi_level) && $multi_level ? '</ul>' : '';
                }
                if (isset($multi_level) && $multi_level) {
                    $output .= '</li>';
                }
            }
            return $output;
        }

        static function get_dropdown_category($galleries)
        {
            $category = array();
            foreach ($galleries as $cat) {
                if(isset($cat['parent']) && $cat['parent']=='#'){
                    $category[$cat['id']] = array(
                        'id' => $cat['id'],
                        'text' => $cat['text'],
                        'is_default' => isset($cat['is_default']) ? $cat['is_default'] : 0
                    );
                    FAT_Maika_Utils::get_dropdown_sub_category($cat['id'], $galleries, $category );
                }
            }
            return $category;
        }

        static function get_dropdown_sub_category($cat_id, $galleries, &$category){
            foreach ($galleries as $cat) {
                if (isset($cat['parent']) && $cat['parent'] == $cat_id ) {
                    $category[$cat['id']] = array(
                        'id' => $cat['id'],
                        'text' => $cat['text'],
                        'is_default' => isset($cat['is_default']) ? $cat['is_default'] : 0
                    );
                    FAT_Maika_Utils::get_dropdown_sub_category($cat['id'], $galleries, $category );
                }
            }
        }

        static function get_imgs($cat_id, $galleries)
        {
            foreach ($galleries as $gallery) {
                if ($gallery['id'] == $cat_id) {
                    return isset($gallery['imgs']) ? $gallery['imgs'] : array();
                }
            }
            return array();
        }

        static function get_image_size_photopile($attachment_id, &$width, &$height)
        {
            try {
                $size = get_post_meta($attachment_id, '_wp_attachment_metadata', true); //wp_get_attachment_metadata($attachment_id);
                $constrain_size = $height;
                if (is_array($size) && isset($size['width']) && isset($size['height'])) {
                    $image_width = $size['width'];
                    $image_height = $size['height'];
                    if ($image_height > $constrain_size) {
                        $percent = $image_height / $constrain_size;
                        $height = $constrain_size;
                        $width = floor($image_width / $percent);
                    } else {
                        $width = $image_width;
                        $height = $image_height;
                    }
                }
            } catch (Exception $e) {
                return;
            }
        }

        public static function enqueue_custom_css($gallery_id, $gallery_config)
        {
            $output_custom_css = '';
            ob_start();
            $css_path = untrailingslashit(FAT_MAIKA_DIR_PATH) . '/assets/css/frontend/sc-custom-css.php';
            if (file_exists($css_path)) {
                include $css_path;
            }
            $output_custom_css .= ob_get_contents();
            ob_end_clean();
            return $output_custom_css;
        }
    }
}